#=====================================================================
# SQL-Ledger Accounting
# Copyright (c) 2001
#
#  Author: Dieter Simader
#   Email: dsimader@sql-ledger.org
#     Web: http://www.sql-ledger.org
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#======================================================================
#
# Accounts Receivables
#
#======================================================================



$form->{printrowcount}=50;
use SL::IS;
use SL::AR;
1;
# end of main

# this is for our long dates
# $locale->text('January')
# $locale->text('February')
# $locale->text('March')
# $locale->text('April')
# $locale->text('May ')
# $locale->text('June')
# $locale->text('July')
# $locale->text('August')
# $locale->text('September')
# $locale->text('October')
# $locale->text('November')
# $locale->text('December')

# this is for our short month
# $locale->text('Jan')
# $locale->text('Feb')
# $locale->text('Mar')
# $locale->text('Apr')
# $locale->text('May')
# $locale->text('Jun')
# $locale->text('Jul')
# $locale->text('Aug')
# $locale->text('Sep')
# $locale->text('Oct')
# $locale->text('Nov')
# $locale->text('Dec')


sub add {

  $form->{title} = "Add";
  $form->{callback} = "$form->{script}?action=add&path=$form->{path}&login=$form->{login}&password=$form->{password}";

if($form->{transdate}){
 $lastbatch = $form->{batch};
 $lastdate = $form->{transdate};
 $lastinvnumber=$form->{invnumber};
 }
   
   &create_links;
   
if($lastdate){
 $form->{transdate}=$lastdate;
$form->{batch}=$lastbatch;
$form->{invnumber}=$lastinvnumber++;
}
  # lock the exchangerate field
  $form->{forex} = 1;
  $form->{"forex_1"} = 1;

  &display_form;

}


sub edit {

  $form->{title} = "Edit";

  &create_links;
  &display_form;

}


sub display_form {

  &form_header;
  &form_footer;

}


sub create_links {

  $form->create_links("AR", \%myconfig, "customer");
#$form->dberror($query);
#  $taxincluded = $form->{AR_links};

  # build the popup menus

  # currencies
  @curr = split /:/, $form->{currencies};
  chomp $curr[0];
  $form->{defaultcurrency} = $curr[0];

  map { $form->{selectcurrency} .= "<option>$_\n" } @curr;

  # customers
  $taxincluded = $form->{taxincluded};
  
  foreach $ref (@{ $form->{all_customer} }) {
    if ($ref->{id} == $form->{customer_id}) {
      $form->{customer} = "$ref->{name}--$ref->{id}";
          $form->{AR} = "$ref->{customernumber}--$ref->{name}";
     $duedate = $form->{duedate};              # save duedate, we are using IS
      IS->get_customer(\%myconfig, \%$form);
      $form->{duedate} = $duedate;              # work-around
    }
    $form->{selectcustomer} .= "<option>$ref->{name}--$ref->{id}\n";
  }
      $form->{creditlimit} = $form->format_amount(\%myconfig, $form->{creditlimit}, 0, "-");
    $form->{creditremaining} = $form->format_amount(\%myconfig, $form->{creditremaining}, 0, "-");

   $form->{taxincluded}=$taxincluded;

  # forex
  $form->{forex} = $form->{exchangerate};

  foreach $key (keys %{ $form->{AR_links} }) {

    foreach $ref (@{ $form->{AR_links}{$key} }) {
      if ($key eq 'AR_tax') {
	$form->{"selectAR_tax_$ref->{accno}"} = "<option>$ref->{accno}--$ref->{description}\n";
	next;
      }
      $form->{"select$key"} .= "<option value='$ref->{accno}--$ref->{description}'>$ref->{accno}--$ref->{description}\n";


    }

    # if there is a value we have an old entry
    # $i is only used for paid
    for $i (1 .. scalar @{ $form->{acc_trans}{$key} }) {
      if ($key eq "AR_paid") {
	$form->{"AR_paid_$i"} = "$form->{acc_trans}{$key}->[$i-1]->{accno}--$form->{acc_trans}{$key}->[$i-1]->{description}";
	# reverse paid
	$form->{"paid_$i"} = $form->{acc_trans}{$key}->[$i-1]->{amount} * -1;
	$form->{"datepaid_$i"} = $form->{acc_trans}{$key}->[$i-1]->{transdate};
	$form->{"source_$i"} = $form->{acc_trans}{$key}->[$i-1]->{source};

	if ($form->{"exchangerate_$i"} = $form->{acc_trans}{$key}->[$i-1]->{exchangerate}) {
	  $form->{"forex_$i"} = 1;
	} else {
	  $form->{"exchangerate_$i"} = 1;
	}

	$form->{paidaccounts}++;
      } else {

	$akey = $key;
	$akey =~ s/AR_//;

        if ($key eq "AR_tax") {

	  $form->{"${key}_$form->{acc_trans}{$key}->[$i-1]->{accno}"} = "$form->{acc_trans}{$key}->[$i-1]->{accno}--$form->{acc_trans}{$key}->[$i-1]->{description}";
	  $form->{"${akey}_$form->{acc_trans}{$key}->[$i-1]->{accno}"} = $form->round_amount($form->{acc_trans}{$key}->[$i-1]->{amount} / $form->{exchangerate}, 2);
	  $totaltax += $form->{"${akey}_$form->{acc_trans}{$key}->[$i-1]->{accno}"};
	} else {
	  $form->{$akey} = $form->round_amount($form->{acc_trans}{$key}->[0]->{amount} / $form->{exchangerate}, 2);
	  $form->{$key} = "$form->{acc_trans}{$key}->[0]->{accno}--$form->{acc_trans}{$key}->[0]->{description}";
	}
      }
    }
  }

  $form->{taxincluded} = $taxincluded if ($form->{id});
  $form->{paidaccounts} = 1 if not defined $form->{paidaccounts};

  $form->{invtotal} = $form->{amount} + $totaltax;
  # amount
  if ($form->{taxincluded}) {
    $form->{amount} += $totaltax;
  }

  $form->{locked} = ($form->datetonum($form->{transdate}, \%myconfig) <= $form->datetonum($form->{closedto}, \%myconfig));

}


sub form_header {

  $title = $form->{title};
  $form->{title} = $locale->text("$title Accounts Receivables");

  $form->{taxincluded} = ($form->{taxincluded}) ? "checked" : "";

# $locale->text('Add Accounts Receivables')
# $locale->text('Edit Accounts Receivables')

  # set option selected
  foreach $item (qw(AR AR_amount customer currency)) {
	  $form->{"$item"} =~ s/\(/;brak/g;
$form->{"select$item"} =~ s/\(/;brak/g;
 #$form->dberror( $form->{"$item"});
$form->{"$item"} =~ s/\)/;2brak/g;
$form->{"select$item"} =~ s/\)/;2brak/g;

$form->{"$item"} =~ s/\[/;brek/g;
$form->{"select$item"} =~ s/\[/;brek/g;

$form->{"$item"} =~ s/\]/;2brek/g;
$form->{"select$item"} =~ s/\]/;2brek/g;

$form->{"select$item"} =~ s/ selected//;
    $form->{"select$item"} =~ s/option value='$form->{$item}'>\Q$form->{$item}\E/option selected value='$form->{$item}'>$form->{$item}/;

    
       $form->{"$item"} =~ s/;brak/\(/g;
$form->{"select$item"} =~ s/;brak/\(/g;

$form->{"$item"} =~ s/;2brak/\)/g;
$form->{"select$item"} =~ s/;2brak/\)/g;

   $form->{"$item"} =~ s/;brek/\[/g;
$form->{"select$item"} =~ s/;brek/\[/g;

$form->{"$item"} =~ s/;2brek/\]/g;
$form->{"select$item"} =~ s/;2brek/\]/g;

  }

  # format amounts
  $form->{amount} = $form->format_amount(\%myconfig, $form->{amount}, 2);
  $form->{exchangerate} = $form->format_amount(\%myconfig, $form->{exchangerate});

  $exchangerate = qq|&nbsp;|;
  if ($form->{currency} ne $form->{defaultcurrency}) {
    if ($form->{forex}) {
      $exchangerate = qq|<input type=hidden name=exchangerate value=$form->{exchangerate}>$form->{exchangerate}|;
    } else {
      $exchangerate = qq|<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=exchangerate size=10 value=$form->{exchangerate}>|;
    }
  }
  $exchangerate .= qq|
<input type=hidden name=forex value=$form->{forex}>
|;

  if (($rows = $form->numtextrows($form->{notes}, 50)) < 2) {
    $rows = 2;
  }
  $notes = qq|<textarea name=notes rows=$rows cols=50 wrap=soft>$form->{notes}</textarea>|;

if(!$form->{nextfocus}){
	$form->{nextfocus}="transtype";
}

  $form->header;
  print qq|


<script>
<!--

function stb(){
        document.myform.$form->{nextfocus}.focus();
}


// -->
</script>

<body bgcolor=ffffff onLoad=stb()>

<form method=post action=$form->{script} name=myform>

<input type=hidden name=id value=$form->{id}>
<input type=hidden name=sort value=$form->{sort}>
<input type=hidden name=closedto value=$form->{closedto}>
<input type=hidden name=locked value=$form->{locked}>
<input type=hidden name=title value="$title">
<input type=hidden name=nextfocus value=$form->{nextfocus}>

<table border=1>
<tr class=listtop bgcolor=000000><th>
<font color=ffffff>$form->{title}</font></th></tr>

<tr valign=top>
<td>

<table>
<tr>
  <th align=right>|.$locale->text('Trans No.').qq|</th>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=transtype  size=4 value="$form->{transtype}">-<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=batch size=6 value="$form->{batch}">-<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=transno  size=4 value="$form->{transno}"><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=subtransno  size=2 value="$form->{subtransno}"></td>
</tr>
<tr>
  <th align=right>|.$locale->text('Sub No.').qq|</th>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=subb  size=4 value="$form->{subb}"></td>
</tr>

<tr>
  <th align=right>|.$locale->text('Project No.').qq|</th>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=project  size=4 value="$form->{project}"></td>
</tr>

<tr>
             <input type=hidden name=keys>
  <input type=hidden name=selectAR value="$form->{selectAR}">

  <th align=right>|.$locale->text('Customer').qq|</th>
  <td colspan=3><select  onkeypress="selectKeyPress();" onkeydown="setsubmit(this);selectKeyDown();" onblur="clr();" onfocus="clr();"  name=AR onChange="this.form.accno2.value=this.options[this.selectedIndex].value">$form->{selectAR}</select></td>
 </tr>

<tr>

 
  <input type=hidden name=selectcustomer value="$form->{selectcustomer}">
  <input type=hidden name=oldcustomer value="$form->{customer_id}">
  <input type=hidden name=terms value=$form->{terms}>
</tr>

<tr>
|;

  if ($form->{taxaccounts}) {
    print qq|

  <th align=right>|.$locale->text('Tax Included').qq|</th>
  <td colspan=3><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=taxincluded class=checkbox type=checkbox value=1 $form->{taxincluded}>
  <b>|.$locale->text('Credit Limit').qq|</b> $form->{creditlimit}
  <b>|.$locale->text('Remaining').qq|</b> $form->{creditremaining}
  </td>
|;

  } else {
    print qq|

  <th align=right>|.$locale->text('Credit Limit').qq|</th>
  <td colspan=3>
  $form->{creditlimit}
  <b>|.$locale->text('Remaining').qq|</b> $form->{creditremaining}
  </td>
|;

  }

print qq|
</tr>

<tr>

  <th align=right>|.$locale->text('Invoice Number').qq|</th>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=invnumber size=20 value="$form->{invnumber}"></td>
  <th align=right>|.$locale->text('Order Number').qq|</th>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=ordnumber size=20 value="$form->{ordnumber}"></td>

</tr>


<tr>

  <th align=right>|.$locale->text('Invoice Date').qq|<br>($myconfig{'dateformat'})</th>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=transdate size=11 value=$form->{transdate}>
             <link rel="stylesheet" media="screen" href="javascript/dynCalendar.css" />
<script language="javascript" type="text/javascript" src="javascript/browserSniffer.js"></script>
<script language="javascript" type="text/javascript" src="javascript/dynCalendar.js"></script>
 
   <script language="JavaScript" type="text/javascript">
    <!--
        /**
        * Example callback function
        */
        function calendar1Callback(date, month, year)
        {
            document.forms['myform'].transdate.value = formatDate(new Date(getDateFromFormat(year + '-' + month + '-' + date,'yyyy-M-d')),'$myconfig{dateformat}');
        }

        calendar1 = new dynCalendar('calendar1', 'calendar1Callback', 'javascript/images/');
    //-->
    </script>
    
    </td>
  <th align=right>|.$locale->text('Due Date').qq|<br>($myconfig{'dateformat'})</th>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=duedate size=11 value=$form->{duedate}></td>

</tr>

<tr>

  <th align=right>|.$locale->text('Currency').qq|</th>
  <td><select  onkeypress="selectKeyPress();" onkeydown="setsubmit(this);selectKeyDown();" onblur="clr();" onfocus="clr();"  name=currency>$form->{selectcurrency}</select></td>
  <th align=right>|.$locale->text('Exchangerate').qq|</th>
  <td>$exchangerate</td>

  <input type=hidden name=selectcurrency value="$form->{selectcurrency}">
  <input type=hidden name=defaultcurrency value=$form->{defaultcurrency}>
  <input type=hidden name=fxgain_accno value=$form->{fxgain_accno}>
  <input type=hidden name=fxloss_accno value=$form->{fxloss_accno}>
</tr>

<tr>

  <th align=right>|.$locale->text('Amount').qq|</th>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=amount size=10 value=$form->{amount}></td>
  <td colspan=2><select  onkeypress="selectKeyPress();" onkeydown="setsubmit(this);selectKeyDown();" onblur="clr();" onfocus="clr();"  name=AR_amount onChange="this.form.accno3.value=this.options[this.selectedIndex].value">$form->{selectAR_amount}</select></td>

  <input type=hidden name=selectAR_amount value="$form->{selectAR_amount}">
</tr>

<input type=hidden name=taxaccounts value="$form->{taxaccounts}">
|;

  
  $taxlabel = ($form->{taxincluded}) ? $locale->text('Tax Included') : $locale->text('Tax');

    $taxrate = 0;

    map { $taxrate += $form->{"${_}_rate"} } split / /, $form->{taxaccounts};
  
  foreach $item (split / /, $form->{taxaccounts}) {
     # $form->{"tax_$item"} = $form->round_amount($form->{amount} * (1 - 1 / (1 + $taxrate)) * $form->{"${item}_rate"} / $taxrate, 2);

    $form->{"tax_$item"} = $form->format_amount(\%myconfig, $form->{"tax_$item"}, 2);
     $form->{"selectAR_tax_$item"} = qq|<option>$item--$form->{"${item}_description"}|;
          # $totaltax += $form->{"tax_$item"};

     print qq|
<tr>

  <th align=right>$taxlabel</th>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="tax_$item" size=9 value=$form->{"tax_$item"}></td>
  <td colspan=2><select  onkeypress="selectKeyPress();" onkeydown="setsubmit(this);selectKeyDown();" onblur="clr();" onfocus="clr();"  name="AR_tax_$item">$form->{"selectAR_tax_$item"}</select></td>

</tr>

<input type=hidden name="${item}_rate" value="$form->{"${item}_rate"}">
<input type=hidden name="${item}_description" value="$form->{"${item}_description"}">
<input type=hidden name="selectAR_tax_$item" value="$form->{"selectAR_tax_$item"}">
|;
  
  }
 # $form->{invtotal} = ($form->{taxincluded}) ? $form->{amount} : $form->{amount} + $totaltax;

  $form->{invtotal} = $form->format_amount(\%myconfig, $form->{invtotal}, 2);

  print qq|
<tr>

  <th align=right>|.$locale->text('Total').qq|</th>
  <td colspan=3>$form->{invtotal}</td>

</tr>

<tr>

  <th align=right>|.$locale->text('Notes').qq|</th>
  <td colspan=3>$notes</td>

</tr>

<tr>
  <td colspan=4>
    <table width=100%>
    <tr class=listheading bgcolor=336666><th colspan=5><font color=ffffff>|.$locale->text('Payments').qq|</font></th></tr>
|;


  @column_index = qw(datepaid paid exchangerate AR_paid source);

  $column_data{datepaid} = "<th>".$locale->text('Date')."<br>($myconfig{dateformat})</th>";
  $column_data{paid} = "<th>".$locale->text('Amount')."</th>";
  $column_data{exchangerate} = "<th>".$locale->text('Exch')."</th>";
  $column_data{AR_paid} = "<th>".$locale->text('Account')."</th>";
  $column_data{source} = "<th>".$locale->text('Source')."</th>";
  
  print "<tr>";
  map { print "$column_data{$_}\n" } @column_index;
  print "</tr>";

  $form->{paidaccounts}++ if ($form->{"paid_$form->{paidaccounts}"});
  for $i (1 .. $form->{paidaccounts}) {
    print "<tr>\n";

    $form->{"selectAR_paid_$i"} = $form->{selectAR_paid};
   # $form->{"selectAR_paid_$i"} =~ s/option>\Q$form->{"AR_paid_$i"}\E/option selected>$form->{"AR_paid_$i"}/;
  	    $form->{"selectAR_paid_$i"} =~ s/option value='$form->{"AR_paid_$i"}'>\Q$form->{"AR_paid_$i"}\E/option selected  value='$form->{"AR_paid_$i"}'>$form->{"AR_paid_$i"}/;

    # format amounts
    $form->{"paid_$i"} = $form->format_amount(\%myconfig, $form->{"paid_$i"}, 2);
    $form->{"exchangerate_$i"} = $form->format_amount(\%myconfig, $form->{"exchangerate_$i"});

    $exchangerate = qq|&nbsp;|;
    if ($form->{currency} ne $form->{defaultcurrency}) {
      if ($form->{"forex_$i"}) {
	$exchangerate = qq|<input type=hidden name="exchangerate_$i" value=$form->{"exchangerate_$i"}>$form->{"exchangerate_$i"}|;
      } else {
	$exchangerate = qq|<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="exchangerate_$i" size=10 value=$form->{"exchangerate_$i"}>|;
      }
    }
    
    $exchangerate .= qq|
<input type=hidden name="forex_$i" value=$form->{"forex_$i"}>
|;

    $column_data{"paid_$i"} = qq|<td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="paid_$i" size=10 value=$form->{"paid_$i"}></td>|;
    $column_data{"AR_paid_$i"} = qq|<td><select  onkeypress="selectKeyPress();" onkeydown="setsubmit(this);selectKeyDown();" onblur="clr();" onfocus="clr();"  name="AR_paid_$i">$form->{"selectAR_paid_$i"}</select></td>|;
    $column_data{"exchangerate_$i"} = qq|<td>$exchangerate</td>|;
    $column_data{"datepaid_$i"} = qq|<td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="datepaid_$i" size=11 value=$form->{"datepaid_$i"}></td>|;
    $column_data{"source_$i"} = qq|<td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="source_$i" size=10 value="$form->{"source_$i"}"></td>|;

    map { print qq|$column_data{"${_}_$i"}\n| } @column_index;
    
    print "</tr>\n";
  }
  
  print qq|
    <input type=hidden name=paidaccounts value=$form->{paidaccounts}>
    <input type=hidden name=selectAR_paid value="$form->{selectAR_paid}">

    </table>
  </td>
  
</tr>
</table>

</td>
</tr>

|;

}


sub form_footer {

  print qq|

<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=callback type=hidden value="$form->{callback}">

<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>
<input type=hidden name=password value=$form->{password}>
<input type=hidden name=action value='Update Form'>

</table>

<br>
|;

  $transdate = $form->datetonum($form->{transdate}, \%myconfig);
  $closedto = $form->datetonum($form->{closedto}, \%myconfig);
  
  if (!$form->{readonly}){
  if ($form->{id}) {
    
      print qq|<input class=submit type=submit name=action value="|.$locale->text('Update').qq|">
|;

    if (!$form->{revtrans}) {
      if (!$form->{locked}) {
	print qq|
	<input class=submit type=submit name=action value="|.$locale->text('Save').qq|">
	<input class=submit type=submit name=action value="|.$locale->text('Delete').qq|">
|;
      }
    }

    if ($transdate > $closedto) {
      print qq|
      <input class=submit type=submit name=action value="|.$locale->text('Post As New Transaction').qq|">
|;
    }

  } else {
    if ($transdate > $closedto) {
      print qq|<input class=submit type=submit name=action value="|.$locale->text('Update').qq|">
      <input class=submit type=submit name=action value="|.$locale->text('Save').qq|">|;
    }
  }
}

  print "</form>

</body>
</html>
";

}


sub save{
	&post_transaction;	
}

sub delete{
	&delete_transaction;	
}



sub update{
	&update_form;	
}



sub update_form {
  # split customer
  $form->{AR1}=$form->{AR};
    ($form->{AR}) = split /--/, $form->{AR};
 #$form->dberror($form->{AR});
  $taxincluded=$form->{taxincluded};
 # ($null, $form->{customer_id}) = split /--/, $form->{customer};
     IS->get_customerid(\%myconfig, \%$form);
#$form->dberror($form->{nextfocus});
  # recalculate form
 # if ($form->{oldcustomer} != $form->{customer_id}) {
	 $form->{customer_id}=$form->{customer_id2};
    IS->get_customer(\%myconfig, \%$form);
  $form->{AR}=$form->{AR1};
    
    $form->{creditlimit} = $form->format_amount(\%myconfig, $form->{creditlimit}, 0, "-");
    $form->{creditremaining} = $form->format_amount(\%myconfig, $form->{creditremaining}, 0, "-");
  $form->{taxincluded}=$taxincluded;

 # }

  $form->{exchangerate} = $exchangerate if ($form->{forex} = ($exchangerate = $form->check_exchangerate(\%myconfig, $form->{currency}, $form->{transdate}, 'buy')));

  # recalculate due date
  $form->{duedate} = $form->current_date(\%myconfig, $form->{transdate}, $form->{terms});

  map { $form->{$_} = $form->parse_amount(\%myconfig, $form->{$_}) } qw(amount exchangerate);

  # recalculate taxes
  if ($form->{taxincluded}) {
    $taxrate = 0;

    map { $taxrate += $form->{"${_}_rate"} } split / /, $form->{taxaccounts};

    foreach $item (split / /, $form->{taxaccounts}) {
    #  $form->{"tax_$item"} = $form->round_amount($form->{amount} * (1 - 1 / (1 + $taxrate)) * $form->{"${item}_rate"} / $taxrate, 2);
       $form->{"tax_$item"} = $form->{amount} * $form->{"${item}_rate"};
     $form->{"selectAR_tax_$item"} = qq|<option>$item--$form->{"${item}_description"}|;
      #$totaltax += $form->{"tax_$item"};
    }
  } else {
    foreach $item (split / /, $form->{taxaccounts}) {
      $form->{"tax_$item"} = $form->{amount} * $form->{"${item}_rate"};
      $form->{"selectAR_tax_$item"} = qq|<option>$item--$form->{"${item}_description"}|;
      $totaltax += $form->{"tax_$item"};
    }
  }

 $form->{invtotal} = ($form->{taxincluded}) ? $form->{amount} : $form->{amount} + $totaltax;

  for $i (1 .. $form->{paidaccounts}) {
    if ($form->{"paid_$i"}) {
      map { $form->{"${_}_$i"} = $form->parse_amount(\%myconfig, $form->{"${_}_$i"}) } qw(paid exchangerate);

      $form->{"exchangerate_$i"} = $exchangerate if ($form->{"forex_$i"} = ($exchangerate = $form->check_exchangerate(\%myconfig, $form->{currency}, $form->{"datepaid_$i"}, 'buy')));
    }
  }


  $taxincluded=$form->{taxincluded};
$form->create_links("AR", \%myconfig, "customer");
  $form->{taxincluded}=$taxincluded;

   foreach $key (keys %{ $form->{AR_links} }) {
  #  $form->{"selectAR"} ="";

    foreach $ref (@{ $form->{AR_links}{$key} }) {
      if ($key eq 'AR_tax') {
	$form->{"selectAR_tax_$ref->{accno}"} = "<option>$ref->{accno}--$ref->{description}\n";
	next;
      }
#      $form->{"select$key"} .= "<option>$ref->{accno}--$ref->{description}\n";

		#	if($form->{"accno1"} eq ''){
		#			$form->{"select$key"} .= "<option>$ref->{accno}--$ref->{description}\n";

		#	}else{
		#		if ($ref->{accno} =~ /^$form->{"accno1"}/){
		#			$form->{"select$key"} .= "<option >$ref->{accno}--$ref->{description}\n";
		#		}
		#	}

    }

    }


    

  &display_form;
  
}


sub post_transaction {

  # check if there is an invoice number, invoice and due date
  $form->isblank("invnumber", $locale->text('Invoice Number missing!'));
  $form->isblank("transdate", $locale->text('Invoice Date missing!'));
  $form->isblank("duedate", $locale->text('Due Date missing!'));

  $closedto = $form->datetonum($form->{closedto}, \%myconfig);
  $transdate = $form->datetonum($form->{transdate}, \%myconfig);
  
  $form->error($locale->text('Cannot post transaction for a closed period!')) if ($transdate <= $closedto);

  $form->isblank("exchangerate", $locale->text('Exchangerate missing!')) if ($form->{currency} ne $form->{defaultcurrency});
  
  for $i (1 .. $form->{paidaccounts}) {
    if ($form->{"paid_$i"}) {
      $datepaid = $form->datetonum($form->{"datepaid_$i"}, \%myconfig);
      
      $form->isblank("datepaid_$i", $locale->text('Payment date missing!'));

      $form->error($locale->text('Cannot post payment for a closed period!')) if ($datepaid <= $closedto);

      if ($form->{currency} ne $form->{defaultcurrency}) {
	$form->{"exchangerate_$i"} = $form->{exchangerate} if ($transdate == $datepaid);
	$form->isblank("exchangerate_$i", $locale->text('Exchangerate for payment missing!'));
      }
    }
  }

    
  # split customer
 # ($null, $form->{customer_id}) = split /--/, $form->{customer};
   ($form->{AR}) = split /--/, $form->{AR};
    $taxincluded=$form->{taxincluded};

  IS->get_customerid(\%myconfig, \%$form);
  $form->{customer_id}=$form->{customer_id2};
  # recalculate form
  #if ($form->{oldcustomer} != $form->{customer_id}) {
    IS->get_customer(\%myconfig, \%$form);
  #}
  $form->{taxincluded}=$taxincluded;

  $form->isposted(AR->post_transaction(\%myconfig, \%$form));

}


sub post_as_new_transaction {

  $form->{id} = 0;
  &post_transaction;

}


sub delete_transaction {

  $form->{title} = $locale->text('Confirm!');
  
  $form->header;

  print qq|
<body bgcolor=ffffff>

<form method=post action=$form->{script}>
|;

  foreach $key (keys %$form) {
    print qq|<input type=hidden name=$key value="$form->{$key}">\n|;
  }

  print qq|
<h2><font color=blue>$form->{title}</font></h2>

<h4>|.$locale->text('Are you sure you want to delete Transaction').qq| $form->{invnumber}</h4>

<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=action class=submit type=submit value="|.$locale->text('Yes Delete Transaction').qq|">
</form>

</body>
</html>
|;

}



sub yes_delete_transaction {

  $form->isdeleted(AR->delete_transaction(\%myconfig, \%$form));

}


sub search {

  # setup customer selection
  $form->all_vc(\%myconfig, "customer");

  $selection = "<option selected>" . $locale->text('All Customers') . "\n";

  foreach $ref (@{ $form->{all_customer} }) {
    $selection .= "<option>$ref->{customernumber}::$ref->{name}--$ref->{id}\n";
  }

   $invoice=$locale->text('Invoice');
 
  if ($form->{nextsub} eq "payments") {
    $form->{title} = $locale->text('Process Payments');
    $listopen = qq|
    <input type=hidden name=sort value=invnumber>
    <input type=hidden name=open value=Y>|;
  }
  if ($form->{nextsub} eq "ar_transactions") {
    $form->{title} = $locale->text('AR Transactions');


  }
###new added
 	$order=$locale->text('Order');
 if($form->{nextsub} eq "sales_book_report"){
  $form->{title} = $locale->text('SALES BOOK');
    $invoice=$locale->text('Invoice');
  }
  if($form->{nextsub} eq "cash_sales"){
  $form->{title} = $locale->text('CASH SALES');
    $invoice=$locale->text('Description');
	$order=$locale->text('Book No.');

  }
  if($form->{nextsub} eq "daily_sales"){
  $form->{title} = $locale->text('DAILY SALES');
   $invoice=$locale->text('Invoice');
  }

  
  $listopen = qq|
<input type=hidden name=sort value=transdate>
<tr>
<td colspan=4>
    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_option" class=checkbox type=checkbox value=Y  $form->{l_option}>&nbsp;|.$locale->text('Show Search Criteria').qq|
</td>
</tr>
<tr>
  <th align=right>|.$locale->text('Include in Report').qq|</th>
  <td colspan=3>
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=open class=checkbox type=checkbox value=Y $form->{open}>&nbsp;|.$locale->text('Open').qq|
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=closed class=checkbox type=checkbox value=Y $form->{closed}>&nbsp;|.$locale->text('Closed').qq|

  <br>
    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_sr" class=checkbox type=checkbox value=Y $form->{l_sr}>&nbsp;|.$locale->text('SR').qq|
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_trans" class=checkbox type=checkbox value=Y $form->{l_trans}>&nbsp;|.$locale->text('Trans no.').qq|
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_subb" class=checkbox type=checkbox value=Y $form->{l_subb}>&nbsp;|.$locale->text('Sub no.').qq|
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_project" class=checkbox type=checkbox value=Y $form->{l_project}>&nbsp;|.$locale->text('Project').qq|
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_id" class=checkbox type=checkbox value=Y $form->{l_id}>&nbsp;|.$locale->text('ID').qq|
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_invnumber" class=checkbox type=checkbox value=Y $form->{l_invnumber}>&nbsp;|.$invoice.qq|
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_ordnumber" class=checkbox type=checkbox value=Y $form->{l_ordnumber}>&nbsp;|.$order.qq|
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_transdate" class=checkbox type=checkbox value=Y $form->{l_transdate}>&nbsp;|.$locale->text('Invoice Date').qq|<br>
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_dow" class=checkbox type=checkbox value=Y $form->{l_dow}>&nbsp;|.$locale->text('Day of Week').qq|<br>
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_customernumber" class=checkbox type=checkbox value=Y $form->{l_customernumber}>&nbsp;|.$locale->text('Customer Number').qq|
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_name" class=checkbox type=checkbox value=Y $form->{l_name}>&nbsp;|.$locale->text('Customer').qq|
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_netamount" class=checkbox type=checkbox value=Y $form->{l_netamount}>&nbsp;|.$locale->text('Amount').qq|
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_tax" class=checkbox type=checkbox value=Y $form->{l_tax}>&nbsp;|.$locale->text('Tax').qq|
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_rowcount" class=checkbox type=checkbox value=Y $form->{l_rowcount}>&nbsp;|.$locale->text('Total Rows').qq|<br>
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_amount" class=checkbox type=checkbox value=Y $form->{l_amount}>&nbsp;|.$locale->text('Total').qq|<br>
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_datepaid" class=checkbox type=checkbox value=Y $form->{l_datepaid}>&nbsp;|.$locale->text('Date Paid').qq|
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_paid" class=checkbox type=checkbox value=Y $form->{l_paid}>&nbsp;|.$locale->text('Paid').qq|
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_duedate" class=checkbox type=checkbox value=Y $form->{l_duedate}>&nbsp;|.$locale->text('Due Date').qq|
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_salesperson" class=checkbox type=checkbox value=Y $form->{l_duedate}>&nbsp;|.$locale->text('Sales Person').qq|
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_due" class=checkbox type=checkbox value=Y $form->{l_due}>&nbsp;|.$locale->text('Due').qq|
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_terms" class=checkbox type=checkbox value=Y $form->{l_terms}>&nbsp;|.$locale->text('Terms').qq|
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_notes" class=checkbox type=checkbox value=Y $form->{l_notes}>&nbsp;|.$locale->text('Notes').qq|<br>
 <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_printl" class=checkbox type=checkbox value=Y $form->{l_printl}>&nbsp;|.$locale->text('Print').qq|<br>
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_subtotal" class=checkbox type=checkbox value=Y $form->{l_subtotal}>&nbsp;|.$locale->text('Subtotal').qq|

</td>
</tr>
|;

  $form->header;

  print qq|
<body bgcolor=ffffff>

<form method=post  action=$form->{script} name=myform>

<table border=1 width=100%>
<tr><th class=listtop bgcolor=000000><font color=ffffff>$form->{title}</font></th></tr>

<tr><td>

<table>

<tr>

<th align=right>|.$locale->text('Customer').qq|</th>
<td colspan=3><select  onkeypress="selectKeyPress();" onkeydown="setsubmit(this);selectKeyDown();" onblur="clr();" onfocus="clr();"  name=customer>$selection</select></td>

</tr>

<tr>

  <th align=right>|.$locale->text('Trans No.').qq|</th>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=transtypeno  size=4 value="$form->{transtypeno}">-<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=batchno size=6 value="$form->{batchno}">-<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=transnono  size=4 value="$form->{transnono}"><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=subtransno  size=2 value="$form->{subtransnono}"></td>

</tr>

<tr>

<th align=right>|.$locale->text('Project Number').qq|</th>
<td colspan=3><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=project size=20></td>
<th align=right>|.$locale->text('Sub Number').qq|</th>
<td colspan=3><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=subb size=20></td>

</tr>
<tr>

<th align=right>|.$locale->text('Invoice Number').qq|</th>
<td ><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=invnumber3 size=20></td>

</tr>
<tr>

<th align=right>|.$locale->text('From Invoice Number').qq|</th>
<td ><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=invnumber size=20></td>
<th align=right>|.$locale->text('To Invoice Number').qq|</th>
<td ><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=invnumber2 size=20></td>

</tr>

<tr>

<th align=right>|.$locale->text('Order Number').qq|</th>
<td colspan=3><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=ordnumber size=20></td>

<th align=right>|.$locale->text('Sales Person').qq|</th>
<td colspan=3><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=shippingpoint size=20></td>

</tr>

<tr>

<th align=right>|.$locale->text('Notes').qq|</th>
<td colspan=3><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=notes size=50></td>

</tr>

<tr>


  
    
<th align=right>|.$locale->text('From').qq|<br>($myconfig{dateformat})</th>
<td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=transdatefrom size=11>
<link rel="stylesheet" media="screen" href="javascript/dynCalendar.css" />
<script language="javascript" type="text/javascript" src="javascript/browserSniffer.js"></script>
<script language="javascript" type="text/javascript" src="javascript/dynCalendar.js"></script>
 
   <script language="JavaScript" type="text/javascript">
    <!--
        /**
        * Example callback function
        */
        function calendar1Callback(date, month, year)
        {
            document.forms['myform'].transdatefrom.value = formatDate(new Date(getDateFromFormat(year + '-' + month + '-' + date,'yyyy-M-d')),'$myconfig{dateformat}');
        }

        calendar1 = new dynCalendar('calendar1', 'calendar1Callback', 'javascript/images/');
    //-->
    </script>
    
</td>
<th align=right>|.$locale->text('To').qq|</th>
<td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=transdateto size=11>
  <script language="JavaScript" type="text/javascript">
    <!--
        /**
        * Example callback function
        */
        function calendar1Callback2(date, month, year)
        {
            document.forms['myform'].transdateto.value = formatDate(new Date(getDateFromFormat(year + '-' + month + '-' + date,'yyyy-M-d')),'$myconfig{dateformat}');
        }

        calendar2 = new dynCalendar('calendar2', 'calendar1Callback2', 'javascript/images/');
    //-->
    </script>

</td>

</tr>

$listopen


</table>

</td></tr>
</table>

<input type=hidden name=nextsub value=$form->{nextsub}>

<input type=hidden name=readonly value=$form->{readonly}>
<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>
<input type=hidden name=password value=$form->{password}>
<input type=hidden name=sort value=transdate>
<input type=hidden name=print_invoice_mod value=$form->{print_invoice_mod}>
<input type=hidden name=print_pl_mod value=$form->{print_pl_mod}>
<input type=hidden name=printrowcount value=$form->{printrowcount}>
<input type=hidden name=pagebreak value=$form->{pagebreak}>
<input type=hidden name=must_select_item value=$form->{must_select_item}>
<input type=hidden name=show_all_price value=$form->{show_all_price}>
<input type=hidden name=printtitle value='$form->{printtitle}'>
<input type=hidden name=nextfocus value='$form->{nextfocus}'>
<input type=hidden name=keys >
<br>
<input class=submit type=submit name=action value="|.$locale->text('Continue').qq|">
<input class=submit type=submit name=action value="|.$locale->text('Ar Transaction Print').qq|">

</form>

<p>
|.$locale->text('To display all transactions, leave fields blank')

.qq|

</body>
</html>
|;

}


sub search2 {
   

  $form->{title} = $locale->text('Sales Summary')." ".$locale->text('Reports');

  $form->header;



  print qq|
<body bgcolor=ffffff>

<form method=post action=$form->{script}>

<input type=hidden name=sort value=customernumber>
<input type=hidden name=add value=1>

<table border=1>
<tr><th class=listtop bgcolor=000000><font color=ffffff>$form->{title}</font></th></tr>

<tr valign=top>
<td>
<table>



<tr>

<th align=right>|.$locale->text('From').qq|<br>($myconfig{dateformat})</th>
<td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=transdatefrom size=11></td>
<th align=right>|.$locale->text('To').qq|</th>
<td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=transdateto size=11></td>

</tr>

<tr>

  <th align=right>|.$locale->text('Include in Report').qq|</th>
  <td colspan=3>

    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_sr" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('SR').qq|
     <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_customernumber" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Customer no.').qq|
    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_name" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Customer name').qq|
    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_amount" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Amount').qq|

    </td>

  </tr>


</table>
</td>

</tr>
</table>

<input type=hidden name=nextsub value=sales_report>
<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>
<input type=hidden name=password value=$form->{password}>
<input type=hidden name=keys >
<br>
<input class=submit type=submit name=action value="|.$locale->text('Generate Report').qq|">
<input class=submit type=submit name=action value="|.$locale->text('Generate Report Print').qq|">
</form>

<p>
|.$locale->text('To display all transactions, leave fields blank')

  .qq|

</body>
</html>
|;
}
sub generate_report {
 &{$form->{nextsub}}(\%myconfig, \%$form);
}
sub generate_report_print {
 $form->{print}="true";
 &{$form->{nextsub}}(\%myconfig, \%$form);
}

sub continue {

  &{ $form->{nextsub} };

}

##new added
sub sales_book_report {
$invoice =$locale->text('Invoice');
$notes =$locale->text('Notes');
   $form->{subtype}="";
  $form->{nextsub}="sales_book_report";
 &ar_transactions1;
}

##new added
sub cash_sales {
$invoice = $locale->text('C/S No.');
$notes = $locale->text('Book No.');
  $form->{subtype}="cash";
  $form->{nextsub}="cash_sales";
  &ar_transactions1;
}

sub daily_sales {
$invoice =$locale->text('Invoice');
$notes =$locale->text('Notes');
  $form->{subtype}="";
  $form->{nextsub}="daily_sales";
  &ar_transactions1;
}

sub ar_transactions {
$invoice = $locale->text('Invoice');
$notes = $locale->text('Notes');
  $form->{subtype}="";
  $form->{nextsub}="ar_transactions";
  &ar_transactions1;
}

sub pagetableheader {

print qq|
<tr $listheading >|;

if($form->{l_sr}){
	print "<th $listprint>$line".$locale->text('SR')."$line</th>";
}
  map { print "\n$column_header{$_}" } @column_index;

  print qq|
  </tr>
|;


}

sub sortheading {
 	print qq|<tr>
	<td $listprint colspan=$colspan><br><b>$column_title{"$form->{sort}"} :</b>$ar->{"$form->{sort}"}
|;
if($form->{sort} eq "customernumber"){
 	  print qq|
	  	&nbsp;&nbsp;&nbsp;&nbsp;<b>$column_title{name} :</b>$ar->{name}|;
  }
 	print qq|
	</td>
	</tr>
|;

	
}



sub ar_transactions1 {
 map { $form->{$_} = $myconfig{$_} } (qw(company address businessnumber nativecurr fy));
 if(!$form->{print}){
    $listheading="class=listheading";
    $listheadingcolor="color=ffffff";
    $listtop="class=listtop";
    $listrow="class=listrow";
    $listtotal="class=listtotal";
    $listsubtotal="class=listsubtotal";
    $lastline=$locale->text('Click on table headers to sort table')."<br>".$locale->text('Click on invoice number to edit transaction');
     $mouseaction[0]=" onmouseover=\"this.className = 'listover';\" onmouseout=\"this.className = 'listrow0';\"";
    $mouseaction[1]=" onmouseover=\"this.className = 'listover';\" onmouseout=\"this.className = 'listrow1';\"";
     }else{
    $line = "<hr size=2 noshade>";
    $fontsize="size=1";
  $listprint="class=print";
   $listheading="class=print";
    $listtop="class=print";
    $listrow="class=print";
    $listsubtotal="class=print";
  }

  # split customer
  ($customer, $form->{customer_id}) = split(/--/, $form->{customer});

  AR->ar_transactions(\%myconfig, \%$form);
   $invoice=$locale->text('Invoice');

  # construct href
  $href = "$form->{script}?action=ar_transactions&printrowcount=$form->{printrowcount}&print=$form->{print}&taxincluded=$form->{taxincluded}&nextsub=purchase_book_report&nextfocus=transtype&path=$form->{path}&login=$form->{login}&password=$form->{password}&transdatefrom=$form->{transdatefrom}&transdateto=$form->{transdateto}&open=$form->{open}&closed=$form->{closed}&invnumber=".$form->escape($form->{invnumber})."&ordnumber=".$form->escape($form->{ordnumber})."&notes=".$form->escape($form->{notes})."&vendor=".$form->escape($form->{vendor})."&transnono=".$form->escape($form->{transnono})."&batchno=".$form->escape($form->{batchno})."&transtypeno=".$form->escape($form->{transtypeno})."&subtransno=".$form->escape($form->{subtransno})."&project=".$form->escape($form->{project})."&subb=".$form->escape($form->{subb})."&printtitle=".$form->escape($form->{printtitle});

  # construct callback
  $customer = $form->{customer};
  $customer =~ s/&/_/g;
  $customer =~ s/ /%20/g; 
  $callback = "$form->{script}?action=ar_transactions&printrowcount=$form->{printrowcount}&print=$form->{print}&taxincluded=$form->{taxincluded}&must_select_item=$form->{must_select_item}&show_all_price=$form->{show_all_price}&pagebreak=$form->{pagebreak}&print_pl_mod=$form->{print_pl_mod}&print_invoice_mod=$form->{print_invoice_mod}&printrowcount=$form->{printrowcount}&nextsub=$form->{nextsub}&nextfocus=transtype&subtype=$form->{subtype}&transdatefrom=$form->{transdatefrom}&transdateto=$form->{transdateto}&open=$form->{open}&closed=$form->{closed}&login=$form->{login}&password=$form->{password}&path=$form->{path}&invnumber=$form->{invnumber}&ordnumber=$form->{ordnumber}&notes=$form->{notes}&customer=$customer&transnono=$form->{transnono}&batchno=$form->{batchno}&transtypeno=$form->{transtypeno}&subtransno=$form->{subtransno}&project=$form->{project}&subb=$form->{subb}&printtitle=".$form->escape($form->{printtitle});



  @columns = $form->sort_columns(qw(trans subb project transdate dow id invnumber ordnumber customernumber name terms duedate rowcount netamount tax  amount paid datepaid due   notes  salesperson printl ));

  foreach $item (@columns) {
    if ($form->{"l_$item"} eq "Y") {
      push @column_index, $item;

      # add column to href and callback
      $callback .= "&l_$item=Y";
      $href .= "&l_$item=Y";
    }
  }

  if ($form->{l_subtotal} eq 'Y') {
    $callback .= "&l_subtotal=Y";
    $href .= "&l_subtotal=Y";
  }



    if ($form->{l_sr} eq 'Y') {
    $callback .= "&l_sr=Y";
    $href .= "&l_sr=Y";
  }
  
       if ($form->{l_description} eq 'Y') {
   	$description =$locale->text('Account Name & Description');
  }else{
    	$description =$locale->text('Account Name');

  }

  $order=$locale->text('Order');

  if($form->{nextsub} eq "ar_transactions"){
  $form->{title} = $locale->text('AR Transactions');
  }
  if($form->{nextsub} eq "sales_book_report"){
  $form->{title} = $locale->text('SALES BOOK');
    $lastline2 = 'Y';
    $invoice=$locale->text('Invoice');
  }
  if($form->{nextsub} eq "cash_sales"){
  $form->{title} = $locale->text('CASH SALES');
   $lastline2 = 'Y';
    $invoice=$locale->text('Description');
	$order=$locale->text('Book No.');

  }
  if($form->{nextsub} eq "daily_sales"){
  $form->{title} = $locale->text('DAILY SALES');
    $lastline2 = 'Y';
    $invoice=$locale->text('Invoice');
 }
  
  $column_title{id} = 	    $locale->text('ID');
  $column_title{trans} =   $locale->text('Trans No.');
  $column_title{subb} =    $locale->text('Sub No.');
  $column_title{project}=  $locale->text('Project No.');
  $column_title{transdate}=$locale->text('Date');
  $column_title{dow} =     $locale->text('DOW');
  $column_title{duedate} = $locale->text('Due Date');
  $column_title{terms} =   $locale->text('Terms');
  $column_title{invnumber}=$invoice;
  $column_title{ordnumber}=$order;
  $column_title{customernumber} = $locale->text('Account');
  $column_title{name} =    $description;
  $column_title{netamount}= $locale->text('Amount') ;
  $column_title{tax} =      $locale->text('Tax') ;
  $column_title{rowcount} = $locale->text('Total Rows') ;
  $column_title{amount} =   $locale->text('Total');
  $column_title{paid} =    $locale->text('Paid') ;
  $column_title{datepaid} =$locale->text('Date Paid') ;
  $column_title{due} =     $locale->text('Due') ;
  $column_title{notes} =   $notes;
  $column_title{printl} =  $locale->text('Print');
  $column_title{salesperson}= $locale->text('Sales Person');

  $column_header{id} = 	    "<th $listprint><a $listheading href=$href&sort=id>$line$column_title{id}</a>$line</th>";
  $column_header{trans} =   "<th $listprint><a $listheading href=$href&sort=transtype>$line$column_title{trans}$line</th>";
  $column_header{subb} =    "<th $listprint><a $listheading href=$href&sort=subb>$line$column_title{subb}$line</th>";
  $column_header{project}=  "<th $listprint><a $listheading href=$href&sort=project>$line$column_title{project}$line</th>";
  $column_header{transdate}="<th $listprint><a $listheading href=$href&sort=transdate>$line$column_title{transdate}</a>$line</th>";
  $column_header{dow} =     "<th $listprint><a $listheading href=$href&sort=dow>$line$column_title{dow}</a>$line</th>";
  $column_header{duedate} = "<th $listprint><a $listheading href=$href&sort=duedate>$line$column_title{duedate}</a>$line</th>";
  $column_header{terms} =   "<th $listprint><a $listheading href=$href&sort=duedate>$line$column_title{terms}</a>$line</th>";
  $column_header{invnumber}="<th $listprint><a $listheading href=$href&sort=invnumber>$line$column_title{invnumber}</a>$line</th>";
  $column_header{ordnumber}="<th $listprint><a $listheading href=$href&sort=ordnumber>$line$column_title{ordnumber}</a>$line</th>";
  $column_header{customernumber} = "<th $listprint><a $listheading href=$href&sort=customernumber>$line$column_title{customernumber}</a>$line</th>";
  $column_header{name} =    "<th $listprint><a $listheading href=$href&sort=customernumber>$line$column_title{name}</a>$line</th>";
  $column_header{netamount}="<th $listprint>$line$column_title{netamount}$line</th>";
  $column_header{tax} =     "<th $listprint>$line$column_title{tax}$line</th>";
  $column_header{rowcount} ="<th $listprint>$line$column_title{rowcount}$line</th>";
  $column_header{amount} =  "<th $listprint>$line$column_title{amount}$line</th>";
  $column_header{paid} =    "<th $listprint>$line$column_title{paid}$line</th>";
  $column_header{datepaid} ="<th $listprint><a $listheading href=$href&sort=datepaid>$line$column_title{datepaid}</a>$line</th>";
  $column_header{due} =     "<th $listprint>$line$column_title{due}$line</th>";
  $column_header{notes} =   "<th $listprint><a $listheading>$line$column_title{notes}$line</th>";
  $column_header{printl} =  "<th $listprint><a $listheading>$line$column_title{printl}$line</th>";
  $column_header{salesperson}="<th $listprint><a $listheading>$line$column_title{salesperson}$line</th>";



  ($customer) = split /--/, $form->{customer};
  if ($form->{customer_id}) {
    $option .= $customer;
  }
  if ($form->{invnumber2}) {
    $option .= "\n<br>" if ($option);
    $option .= $locale->text('To Invoice Number')." : $form->{invnumber2}";
   $callback .= "&invnumber2=$form->{invnumber2}";
    $href .= "&invnumber2=$form->{invnumber2}";
  }
    if ($form->{invnumber3}) {
    $option .= "\n<br>" if ($option);
    $option .= $locale->text('Invoice Number')." : $form->{invnumber3}";
   $callback .= "&invnumber3=$form->{invnumber3}";
    $href .= "&invnumber3=$form->{invnumber3}";
  }
    if ($form->{invnumber}) {
    $option .= "\n<br>" if ($option);
    $option .= $locale->text('From Invoice Number')." : $form->{invnumber}";
   $callback .= "&invnumber=$form->{invnumber}";
    $href .= "&invnumber=$form->{invnumber}";
  }
  
  if ($form->{transtypeno}) {
    $option .= "\n<br>" if ($option);
    $option .= $locale->text('Trans type')." : $form->{transtypeno}";
  }
  if ($form->{batchno}) {
    $option .= "\n<br>" if ($option);
    $option .= $locale->text('Batch')." : $form->{batchno}";
  }
  if ($form->{transnono}) {
    $option .= "\n<br>" if ($option);
    $option .= $locale->text('Trans no')." : $form->{transnono}";
  }
  if ($form->{subtransnono}) {
    $option .= "\n<br>" if ($option);
    $option .= $locale->text('Sub Trans no')." : $form->{subtransnono}";
  }

  if ($form->{ordnumber}) {
    $option .= "\n<br>" if ($option);
    $option .= $locale->text('Order Number')." : $form->{ordnumber}";
  }
  if ($form->{notes}) {
    $option .= "\n<br>" if ($option);
    $option .= $locale->text('Notes')." : $form->{notes}";
  }
  if ($form->{transdatefrom}) {
    $option .= "\n<br>" if ($option);
    $option .= $locale->text('From')."&nbsp;".$locale->date(\%myconfig, $form->{transdatefrom}, 1);
  }
  if ($form->{transdateto}) {
    $option .= "\n<br>" if ($option);
    $option .= $locale->text('To')."&nbsp;".$locale->date(\%myconfig, $form->{transdateto}, 1);
  }
  if ($form->{open}) {
    $option .= "\n<br>" if ($option);
    $option .= $locale->text('Open');
  }
  if ($form->{closed}) {
    $option .= "\n<br>" if ($option);
    $option .= $locale->text('Closed');
  }

    if ($form->{l_subtotal} eq 'Y') {


  @column_index = grep !/$form->{sort}/, @column_index;
  
  if($form->{sort} eq "customernumber"){
  @column_index = grep !/name/, @column_index;	  
  }
    }
  $colspan = $#column_index + 1;
	    $option ='' if(!$form->{l_option})  ;

  $form->header;

  print qq|

  <script>
<!--

function set(n) 
{
               temp = document.myform.elements.length  ;
                 
               for (i=0; i < temp; i++)
	{   document.myform.elements[i].checked=n;
	   }
} 

function Invers(){

temp = document.myform.elements.length ;
                 
for (i=0; i < temp; i++){

          if(document.myform.elements[i].checked == 1){document.myform.elements[i].checked = 0;}
                else {document.myform.elements[i].checked = 1}
               
              }

}
// -->
</script>
<body bgcolor=ffffff>
<p >F/Y : $form->{fy}</p>
<H1  $listprint align=center >$form->{company}<br>$form->{title}</h1>
<form method=post action=ar.pl name=myform>
<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=callback type=hidden value="$form->{callback}">

<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>
<input type=hidden name=password value=$form->{password}>
<input type=hidden name=printtitle value='$form->{printtitle}'>
$option
<table $listprint border=0 width=100%>
|;


  # add sort and escape callback
  $callback = $form->escape("$callback&sort=$form->{sort}");

  if (@{ $form->{AR} }) {
    $sameitem = $form->{AR}->[0]->{$form->{sort}};
  }
		&pagetableheader;

  # sums and tax on reports by Antonio Gallardo
  #
  foreach $ar (@{ $form->{AR} }) {
	  if(!$stopprintheading){
		  if ($form->{l_subtotal} eq 'Y') {
				 &sortheading;
		  }
		$stopprintheading="true";
	  }
	  
    if ($form->{l_subtotal} eq 'Y') {
      if ($sameitem ne $ar->{$form->{sort}}) {
	&ar_subtotal;
		  if ($form->{l_subtotal} eq 'Y') {
				 &sortheading;
		  }

   #      &pagetableheader;
         $r+=3;
      }
    }



    $column_data{netamount} = "<td  $listprint align=right>".$form->format_amount(\%myconfig, $ar->{netamount}, 2, "&nbsp;")."</td>";
    $column_data{tax} = "<td  $listprint  align=right>".$form->format_amount(\%myconfig, $ar->{amount} - $ar->{netamount}, 2, "&nbsp;")."</td>";
    $column_data{rowcount} = "<td   $listprint align=right>". $ar->{rowcount}."</td>";
    $column_data{amount} = "<td   $listprint align=right>".$form->format_amount(\%myconfig, $ar->{amount}, 2, "&nbsp;")."</td>";
    $column_data{paid} = "<td   $listprint align=right>".$form->format_amount(\%myconfig, $ar->{paid}, 2, "&nbsp;")."</td>";
    $column_data{due} = "<td   $listprint align=right>".$form->format_amount(\%myconfig, $ar->{amount} - $ar->{paid}, 2, "&nbsp;")."</td>";

    $subtotalnetamount += $ar->{netamount};
    $subtotalamount += $ar->{amount};
    $subtotalpaid += $ar->{paid};
    $subtotaldue += $ar->{amount} - $ar->{paid};

    $totalnetamount += $ar->{netamount};
    $totalamount += $ar->{amount};
    $totalpaid += $ar->{paid};
    $totaldue += ($ar->{amount} - $ar->{paid});

       $pagetotalnetamount += $ar->{netamount};
    $pagetotalamount += $ar->{amount};
    $pagetotalpaid += $ar->{paid};
    $pagetotaldue += ($ar->{amount} - $ar->{paid});

    $column_data{transdate} = "<td  $listprint >$ar->{transdate}&nbsp;</td>";
    $column_data{dow} = "<td  $listprint >$ar->{dow}&nbsp;</td>";
    $column_data{id} = "<td  $listprint >$ar->{id}</td>";
    $column_data{datepaid} = "<td  $listprint >$ar->{datepaid}&nbsp;</td>";
    $column_data{duedate} = "<td  $listprint >$ar->{duedate}&nbsp;</td>";
    $column_data{terms} = "<td  $listprint >$ar->{terms}&nbsp;</td>";

    $module = ($ar->{invoice}) ? "is.pl" : $form->{script};
    

 
    $column_data{invnumber} = "<td  $listprint ><input type=hidden name=id_".($j+1)." value=$ar->{id}><a href=$module?printtitle=".$form->escape($form->{printtitle})."&pagebreak=$form->{pagebreak}&must_select_item=$form->{must_select_item}&show_all_price=$form->{show_all_price}&readonly=$form->{readonly}&print_invoice_mod=$form->{print_invoice_mod}&print_pl_mod=$form->{print_pl_mod}&nextsub=$form->{nextsub}&nextfocus=transtype&subtype=$form->{subtype}&action=edit&id=$ar->{id}&path=$form->{path}&login=$form->{login}&password=$form->{password}&callback=$callback>$ar->{invnumber}</a></td>";
    $column_data{ordnumber} = "<td  $listprint >$ar->{ordnumber}&nbsp;</td>";
    $column_data{customernumber} = "<td  $listprint >$ar->{customernumber}&nbsp;</td>";
    $column_data{name} = "<td   $listprint width=40%>$ar->{name}</td>";
    $column_data{trans} = "<td  $listprint >$ar->{transtype}-$ar->{batch}-$ar->{transno}$ar->{subtransno}</td>";
   $column_data{subb} = "<td  $listprint >$ar->{subb}</td>";
    $column_data{project} = "<td  $listprint >$ar->{project}</td>";
    $ar->{notes} =~ s//<br>/g;
    $column_data{notes} = "<td  $listprint >$ar->{notes}&nbsp;</td>";
    $column_data{salesperson} = "<td  $listprint >$ar->{salesperson}&nbsp;</td>";
    $column_data{printl} = ($ar->{invoice}) ? "<td  $listprint ><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=\"printl_".($j+1)."\" type=checkbox class=checkbox value=".($j+1)." 0> </td>" : "<td $listprint></td>";

    $i++; $i %= 2;
     $j++;
         $r++;

     print "<tr $listrow$i $mouseaction[$i] >";
    if($form->{l_sr}){

    	print "<td  $listprint >$j</td>";
    }

    map { print "\n$column_data{$_}" } @column_index;

    print qq|
</tr>
|;

#pagebreak printing
#if($form->{printrowcount} && $form->{print} && $form->{printrowcount} <= $r){
if($form->{printrowcount} && $form->{print} && $form->{printrowcount} <= $r){
$pagenum++;
    print "<tr $listrow$i  >";
if($form->{l_sr}){
	print "<th $listprint >$line&nbsp;</th>";
}
	
	  map { $column_data{$_} = "<th $listprint >$line&nbsp;</th>" } @column_index;
if($form->{sort} ne "customernumber"){
     $column_data{name} = "<th $listprint align=right >$line SubTotal C/F for Page $pagenum</th>";
}else{
     $column_data{invnumber} = "<th $listprint align=right >$line SubTotal C/F for Page $pagenum</th>";
	
}
if($form->{l_subtotal}){
    $column_data{netamount} = "<th  $listprint align=right>$line".$form->format_amount(\%myconfig, $subtotalnetamount, 2, "0.00")."</th>";
    $column_data{tax} = "<th  $listprint align=right>$line".$form->format_amount(\%myconfig, $subtotalamount - $pagetotalnetamount, 2, "0.00") . "</th>";
    $column_data{amount} = "<th  $listprint align=right>$line".$form->format_amount(\%myconfig, $subtotalamount, 2, "0.00") . "</th>";
    $column_data{paid} = "<th  $listprint align=right>$line".$form->format_amount(\%myconfig, $subtotalpaid, 2, "0.00")."</th>";
    $column_data{due} = "<th  $listprint align=right>$line".$form->format_amount(\%myconfig, $subtotalamount - $subtotalpaid, 2, "0.00")."</th>";
}else{
   $column_data{netamount} = "<th  $listprint align=right>$line".$form->format_amount(\%myconfig, $pagetotalnetamount, 2, "0.00")."</th>";
    $column_data{tax} = "<th  $listprint align=right>$line".$form->format_amount(\%myconfig, $pagetotalamount - $pagetotalnetamount, 2, "0.00") . "</th>";
    $column_data{amount} = "<th  $listprint align=right>$line".$form->format_amount(\%myconfig, $pagetotalamount, 2, "0.00") . "</th>";
    $column_data{paid} = "<th  $listprint align=right>$line".$form->format_amount(\%myconfig, $pagetotalpaid, 2, "0.00")."</th>";
    $column_data{due} = "<th  $listprint align=right>$line".$form->format_amount(\%myconfig, $pagetotalamount - $pagetotalpaid, 2, "0.00")."</th>";
	
}
     map { print "\n$column_data{$_}" } @column_index;

     print qq|
     </tr>
</table>

 <p style="page-break-before: always">F/Y : $form->{fy}</p>
<H1  $listprint align=center >$form->{company}<br>$form->{title}</h1>

<table  $listprint border=0 width=100%>
|;
		  if ($form->{l_subtotal} eq 'Y') {
				 &sortheading;
		  }

&pagetableheader;
		  if ($form->{l_subtotal} eq 'Y') {
				 &sortheading;
		  }
if($form->{l_sr}){
	print "<td $listprint >&nbsp;</td>";
}

 	  map { $column_data{$_} = "<td $listprint >&nbsp;</td>" } @column_index;
if($form->{l_subtotal}){
   $column_data{netamount} = "<td  $listprint align=right>".$form->format_amount(\%myconfig, $subtotalnetamount, 2, "&nbsp;")."</td>";
    $column_data{tax} = "<td  $listprint align=right>".$form->format_amount(\%myconfig, $subtotalamount - $subtotalnetamount, 2, "&nbsp;") . "</td>";
    $column_data{amount} = "<td  $listprint align=right>".$form->format_amount(\%myconfig, $subtotalamount, 2, "&nbsp;") . "</td>";
    $column_data{paid} = "<td  $listprint align=right>".$form->format_amount(\%myconfig, $subtotalpaid, 2, "&nbsp;")."</td>";
    $column_data{due} = "<td  $listprint align=right>".$form->format_amount(\%myconfig, $subtotalamount - $subtotalpaid, 2, "&nbsp;")."</td>";
    
}else{
   $column_data{netamount} = "<td  $listprint align=right>".$form->format_amount(\%myconfig, $pagetotalnetamount, 2, "&nbsp;")."</td>";
    $column_data{tax} = "<td  $listprint align=right>".$form->format_amount(\%myconfig, $pagetotalamount - $pagetotalnetamount, 2, "&nbsp;") . "</td>";
    $column_data{amount} = "<td  $listprint align=right>".$form->format_amount(\%myconfig, $pagetotalamount, 2, "&nbsp;") . "</td>";
    $column_data{paid} = "<td  $listprint align=right>".$form->format_amount(\%myconfig, $pagetotalpaid, 2, "&nbsp;")."</td>";
    $column_data{due} = "<td  $listprint align=right>".$form->format_amount(\%myconfig, $pagetotalamount - $pagetotalpaid, 2, "&nbsp;")."</td>";
	
}
if($form->{sort} ne "customernumber"){
     $column_data{name} = "<td $listprint >**Subtotal B/F for Page $pagenum </td>";
}else{
     $column_data{invnumber} = "<td $listprint >**Subtotal B/F for Page $pagenum </td>";
	
}
    map { print "\n$column_data{$_}" } @column_index;
print qq|
</tr>
|;
$r=0;

		  
}

  }

  if ($form->{l_subtotal} eq 'Y') {
    &ar_subtotal;

  }

  # print totals
  print qq|<tr $listtotal>|;
   if($form->{l_sr}){

    	print "<td  $listprint >&nbsp;</td>";
    }

  map { $column_data{$_} = "<td  $listprint >&nbsp;</td>" } @column_index;

  $column_data{name} = "<th   $listprint align=right>$line".$locale->text('Grand Total')."$line</th>";
  $column_data{netamount} = "<th   $listprint align=right>$line".$form->format_amount(\%myconfig, $totalnetamount, 2, "&nbsp;")."$line</th>";
  $column_data{tax} = "<th   $listprint align=right>$line".$form->format_amount(\%myconfig, $totalamount - $totalnetamount, 2, "&nbsp;")."$line</th>";
  $column_data{amount} = "<th  $listprint  align=right>$line".$form->format_amount(\%myconfig, $totalamount, 2, "&nbsp;")."$line</th>";
  $column_data{paid} = "<th   $listprint align=right>$line".$form->format_amount(\%myconfig, $totalpaid, 2, "&nbsp;")."$line</th>";
  $column_data{due} = "<th   $listprint align=right>$line".$form->format_amount(\%myconfig, $totaldue, 2, "&nbsp;")."$line</th>";

  map { print "\n$column_data{$_}" } @column_index;
  
  if($lastline2 eq 'Y' ){
	$lastline = "<p align=right>".$locale->text('Total for ').$form->{transtypeno}."-".$form->{batchno}."&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ".$form->format_amount(\%myconfig, $totalnetamount, 2, "&nbsp;")."</p><br>".$lastline;
  }



  print qq|
  </tr>

</table>

<p>$lastline
|;
  if($form->{l_printl}  ){
	  print qq| 
	    <br><br><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=button onclick=Invers() type=button value="|.$locale->text('Select All').qq|"> 
	    	    <input class=submit type=submit name=action value="|.$locale->text('Print Invoices').qq|">
	  	<input type=hidden name=password value=$form->{password}>
		<input type=hidden name=printcount value=$j>

	  |;
  }
  
  
  print qq|
  </form>
  </body>
</html>
|;

}

sub print_invoices333 {
 for $x (1 .. $form->{printcount}) {
 $form->{"id"} =$form->{"id_$x"};
 $form->isdeleted(IS->delete_invoice(\%myconfig, \%$form));

 } 	
}


sub print_invoices {
require "$form->{path}/is.pl";
	 $form->header;
 print qq|<body bgcolor="#ffffff">|;
 for $x (1 .. $form->{printcount}) {
 $form->{"pid_$x"} =$form->{"id_$x"};

 }
 for $x (1 .. $form->{printcount}) {
  $form->{title} = $locale->text('Edit Customer Invoice');
 # $form->{printtitle}="I N V O I C E";
 
 $form->{id} =$form->{"pid_$x"};
 # $form->save_query(\%$form,$myconfig->{dbname},$form->{"id_$x"});

  $form->{currentrow}=0;


 $form->{page}=0;
 #$i=0;
$form->{paidaccounts}=0;
$form->{rowcount}=0;

$form->{invtotal}=0;
$form->{invsubtotal}=0;


	 if($form->{"printl_$x"}){
	
	  &invoice_links;
	  &prepare_invoice2; 


	  ####print invoice
			  map { $form->{$_} = $myconfig{$_} } (qw(company address tel fax businessnumber nativecurr fy));
			  $form->{address} =~ s/\\n/<br>/g;
			
			  $form->{type} = "invoice";
			  $form->{label} = $locale->text('Invoice');
			  $form->{vc} = "customer";
			  $form->{printpage}=1;
					  $form->{pagetotal}=0;
	  
			   $y=0;
			  $form->{currentrow}=0;
			  $form->{page}=1;
			  IS->customer_details(\%myconfig, \%$form);
			
			  &print_form_header;
			  for $z (1 .. $form->{rowcount}-1) {
				  $form->{currentrow}++;
				    $y++;
				    if($form->{printinvoicerowcount} > $y){
					    &print_form_row;
				    }else{
					    &print_form_row;
					     &print_page_footer;
					    print qq| <p style="page-break-before: always">&nbsp;</p>|;
					    $form->{page}++;
					    &print_form_header;
					     &print_page_header;
					    $y=0;
				    
				   }
				  

			  }
			  
			  &print_form_footer;
			 print qq| </table><p style="page-break-before: always">&nbsp;</p>|;
	###print all end
	 }


 }
  print qq|    </body></html>|;

}




sub sales_report {
 map { $form->{$_} = $myconfig{$_} } (qw(company address businessnumber nativecurr fy));
 if(!$form->{print}){
    $listheading="class=listheading";
    $listheadingcolor="color=ffffff";
    $listtop="class=listtop";
    $listrow="class=listrow";
    $listtotal="class=listtotal";
    $listsubtotal="class=listsubtotal";
  #  $lastline=$locale->text('Click on table headers to sort table')."<br>".$locale->text('Click on invoice number to edit transaction');
  }else{
    $line = "<hr size=2 noshade>";
    $fontsize="size=1";
  $listprint="class=print";
   $listheading="class=print";
    $listtop="class=print";
    $listrow="class=print";
    $listsubtotal="class=print";
  }

  # split customer
  ($customer, $form->{customer_id}) = split(/--/, $form->{customer});

  AR->sales_report(\%myconfig, \%$form);
   $invoice=$locale->text('Invoice');

  # construct href
  $href = "$form->{script}?action=sales_report&nextsub=$form->{nextsub}&subtype=$form->{subtype}&invnumber=".$form->escape($form->{invnumber})."&ordnumber=".$form->escape($form->{ordnumber})."&notes=".$form->escape($form->{notes})."&transdatefrom=$form->{transdatefrom}&transdateto=$form->{transdateto}&open=$form->{open}&closed=$form->{closed}&customer=".$form->escape($form->{customer})."&login=$form->{login}&password=$form->{password}&path=$form->{path}";

  # construct callback
  $customer = $form->{customer};
  $customer =~ s/&/_/g;
  $callback = "$form->{script}?action=sales_report&nextsub=$form->{nextsub}&subtype=$form->{subtype}&transdatefrom=$form->{transdatefrom}&transdateto=$form->{transdateto}&open=$form->{open}&closed=$form->{closed}&login=$form->{login}&password=$form->{password}&path=$form->{path}&invnumber=$form->{invnumber}&ordnumber=$form->{ordnumber}&notes=$form->{notes}&customer=$customer";

  @columns = $form->sort_columns(qw(customernumber name terms   amount  ));

  foreach $item (@columns) {
    if ($form->{"l_$item"} eq "Y") {
      push @column_index, $item;

      # add column to href and callback
      $callback .= "&l_$item=Y";
      $href .= "&l_$item=Y";
    }
  }

  if ($form->{l_subtotal} eq 'Y') {
    $callback .= "&l_subtotal=Y";
    $href .= "&l_subtotal=Y";
  }



    if ($form->{l_sr} eq 'Y') {
    $callback .= "&l_sr=Y";
    $href .= "&l_sr=Y";
  }
  



  $form->{title} = $locale->text('Sales Report');
 
  
  $column_header{customernumber} = "<th $listprint><a $listheading href=$href&sort=customernumber><font$listheadingcolor>".$locale->text('Account')."</a>$line</th>";
  $column_header{name} = "<th $listprint><a $listheading href=$href&sort=customernumber,name><font$listheadingcolor>".$locale->text('Customer')."</a>$line</th>";
  $column_header{amount} = "<th $listprint>" . $locale->text('Total') . "$line</th>";



  ($customer) = split /--/, $form->{customer};
  if ($form->{customer_id}) {
    $option .= $customer;
  }
 
  if ($form->{transdatefrom}) {
    $option .= "\n<br>" if ($option);
    $option .= $locale->text('From')."&nbsp;".$locale->date(\%myconfig, $form->{transdatefrom}, 1);
  }
  if ($form->{transdateto}) {
    $option .= "\n<br>" if ($option);
    $option .= $locale->text('To')."&nbsp;".$locale->date(\%myconfig, $form->{transdateto}, 1);
  }


  $colspan = $#column_index + 1;


  $form->header;

  print qq|
<body bgcolor=ffffff>
<p >F/Y : $form->{fy}</p>
<H1  $listprint align=center >$form->{company}<br>$form->{title}</h1>

<table $listprint border=0 width=100%>

<tr $listheading >|;
if($form->{l_sr}){
	print "<th $listprint>".$locale->text('SR')."$line</th>";
}
  map { print "\n$column_header{$_}" } @column_index;

  print qq|
  </tr>
|;


  # add sort and escape callback
  $callback = $form->escape("$callback&sort=$form->{sort}");

  if (@{ $form->{AR} }) {
    $sameitem = $form->{AR}->[0]->{$form->{sort}};
  }

  # sums and tax on reports by Antonio Gallardo
  #
  foreach $ar (@{ $form->{AR} }) {

    if ($form->{l_subtotal} eq 'Y') {
      if ($sameitem ne $ar->{$form->{sort}}) {
	&ar_subtotal;
      }
    }



     $column_data{amount} = "<td   $listprint align=right>".$form->format_amount(\%myconfig, $ar->{amount}, 2, "&nbsp;")."</td>";
  
    $subtotalamount += $ar->{amount};
 
    $totalamount += $ar->{amount};
 
    $pagetotalamount += $ar->{amount};
 
    $column_data{terms} = "<td  $listprint >$ar->{terms}&nbsp;</td>";

    $module = ($ar->{invoice}) ? "is.pl" : $form->{script};
    

     $column_data{customernumber} = "<td  $listprint >$ar->{customernumber}&nbsp;</td>";
    $column_data{name} = "<td   $listprint width=40%>$ar->{name}</td>";

    $i++; $i %= 2;
     $j++;
         $r++;

     print "<tr $listrow$i onmouseover=\"this.className = 'listover';\" onmouseout=\"this.className = 'listrow$i';\" >";
    if($form->{l_sr}){

    	print "<td  $listprint >$j</td>";
    }

    map { print "\n$column_data{$_}" } @column_index;

    print qq|
</tr>
|;

#pagebreak printing
if($form->{printrowcount} && $form->{print} && $form->{printrowcount} <= $r){
$pagenum++;
    print "<tr $listrow$i onmouseover=\"this.className = 'listover';\" onmouseout=\"this.className = 'listrow$i';\"  >";
if($form->{l_sr}){
	print "<td $listprint >$line&nbsp;</td>";
}
	
	  map { $column_data{$_} = "<td $listprint >$line&nbsp;</td>" } @column_index;
#     $column_data{name} = "<td $listprint >$line SubTotal</td>";
 #   $column_data{amount} = "<td  $listprint align=right>$line".$form->format_amount(\%myconfig, $pagetotalamount, 2, "&nbsp;") . "</td>";
     map { print "\n$column_data{$_}" } @column_index;

     print qq|
     </tr>
</table>

 <p style="page-break-before: always">F/Y : $form->{fy}</p>
<H1  $listprint align=center >$form->{company}<br>$form->{title}</h1>
<table  $listprint border=0 width=100%>

<tr $listheading>|;
if($form->{l_sr}){
	print "<th $listprint >".$locale->text('SR')."$line</th>";
}
map { print "\n$column_header{$_}" } @column_index;

print qq|
</tr><tr>
|;
if($form->{l_sr}){
	print "<td $listprint >&nbsp;</td>";
}

 	  map { $column_data{$_} = "<td $listprint >&nbsp;</td>" } @column_index;
#    $column_data{amount} = "<td  $listprint align=right>".$form->format_amount(\%myconfig, $pagetotalamount, 2, "&nbsp;") . "</td>";
#     $column_data{name} = "<td $listprint >**Subtotal B/F for Page $pagenum </td>";
    map { print "\n$column_data{$_}" } @column_index;
print qq|
</tr>
|;
$r=0;

}

  }

  if ($form->{l_subtotal} eq 'Y') {
    &ar_subtotal;
  }

  # print totals
  print qq|<tr $listtotal>|;
   if($form->{l_sr}){

    	print "<td  $listprint >&nbsp;</td>";
    }

  map { $column_data{$_} = "<td  $listprint >&nbsp;</td>" } @column_index;

 # $column_data{netamount} = "<th   $listprint align=right>$line".$form->format_amount(\%myconfig, $totalnetamount, 2, "&nbsp;")."</font>$line</th>";
 # $column_data{tax} = "<th   $listprint align=right>$line".$form->format_amount(\%myconfig, $totalamount - $totalnetamount, 2, "&nbsp;")."</font>$line</th>";
 # $column_data{amount} = "<th  $listprint  align=right>$line".$form->format_amount(\%myconfig, $totalamount, 2, "&nbsp;")."</font>$line</th>";
 # $column_data{paid} = "<th   $listprint align=right>$line".$form->format_amount(\%myconfig, $totalpaid, 2, "&nbsp;")."</font>$line</th>";
 # $column_data{due} = "<th   $listprint align=right>$line".$form->format_amount(\%myconfig, $totaldue, 2, "&nbsp;")."$line</th>";

  map { print "\n$column_data{$_}" } @column_index;
  
  if($lastline2 eq 'Y' ){
	$lastline = "<p align=right>".$locale->text('Total for ').$form->{transtypeno}."-".$form->{batchno}."&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ".$form->format_amount(\%myconfig, $totalnetamount, 2, "&nbsp;")."</p><br>".$lastline;
  }

  print qq|
  </tr>

</table>

<p>$lastline

</body>
</html>
|;

}

##NEW ADDED
sub ar_transaction_print {
  $form->{print}="true";
 &ar_transactions1;


}

sub ar_subtotal {

  map { $column_data{$_} = "<th>&nbsp;</th>" } @column_index;

  $column_data{tax} = "<th  $listprint align=right>$line".$form->format_amount(\%myconfig, $subtotalamount - $subtotalnetamount, 2, "&nbsp;")."</th>";
   $column_data{netamount} = "<th  $listprint align=right>$line".$form->format_amount(\%myconfig, $subtotalnetamount, 2, "&nbsp;")."</th>";
 $column_data{amount} = "<th  $listprint align=right>$line".$form->format_amount(\%myconfig, $subtotalamount, 2, "&nbsp;")."</th>";
  $column_data{paid} = "<th  $listprint align=right>$line".$form->format_amount(\%myconfig, $subtotalpaid, 2, "&nbsp;")."</th>";
  $column_data{due} = "<th  $listprint align=right>$line".$form->format_amount(\%myconfig, $subtotaldue, 2, "&nbsp;")."</th>";
   $column_data{name} = "<th  $listprint align=right>$line Subtotal</th>";

  $subtotalnetamount = 0;
  $subtotalamount = 0;
  $subtotalpaid = 0;
  $subtotaldue = 0;

  $sameitem = $ar->{$form->{sort}};

  print "<tr $listsubtotal >";
   if($form->{l_sr}){

    	print "<td  $listprint >&nbsp;</td>";
    }
  map { print "\n$column_data{$_}" } @column_index;

print "
</tr>";
}


sub payments {

  # split customer
  ($customer, $form->{customer_id}) = split(/--/, $form->{customer});
  
  AR->payments(\%myconfig, \%$form);

  # construct href
  $href = "$form->{script}?action=payments&path=$form->{path}&login=$form->{login}&password=$form->{password}&transdatefrom=$form->{transdatefrom}&transdateto=$form->{transdateto}&open=$form->{open}&invnumber=".$form->escape($form->{invnumber})."&ordnumber=".$form->escape($form->{ordnumber})."&customer=".$form->escape($form->{customer});
  
  @column_index = $form->sort_columns(qw(invnumber ordnumber transdate name amount currency exchangerate source));
  
  $column_header{transdate} = "<th><a class=listheading href=$href&sort=transdate><font color=ffffff>".$locale->text('Date')."</font></a></th>";
  $column_header{invnumber} = "<th><a class=listheading href=$href&sort=invnumber><font color=ffffff>".$locale->text('Invoice')."</font></a></th>";
  $column_header{ordnumber} = "<th><a class=listheading href=$href&sort=ordnumber><font color=ffffff>".$locale->text('Order')."</font></a></th>";
  $column_header{name} = "<th><a class=listheading href=$href&sort=name><font color=ffffff>".$locale->text('Customer')."</font></a></th>";
  $column_header{amount} = "<th><font color=ffffff>".$locale->text('Amount')."</font></th>";
  $column_header{currency} = "<th><font color=ffffff>".$locale->text('Curr')."</font></th>";
  $column_header{exchangerate} = "<th><font color=ffffff>".$locale->text('Exchangerate')."</font></th>";
  $column_header{source} = "<th><font color=ffffff>".$locale->text('Source')."</font></th>";


  $form->{title} = $locale->text('Process Payments');
  $colspan = $#column_index + 1;

  $form->header;
    
  print qq|
<body bgcolor=ffffff>

<form action=$form->{script} method=post>

<input type=hidden name=defaultcurrency value=$form->{defaultcurrency}>
<input type=hidden name=fxgain_accno value=$form->{fxgain_accno}>
<input type=hidden name=fxloss_accno value=$form->{fxloss_accno}>

<input type=hidden name=closedto value=$form->{closedto}>

<table border=0>
<tr><th class=listtop bgcolor=000000 colspan=$colspan><font color=ffffff>$form->{title}</font></th></tr>

<tr class=listheading bgcolor=336666>
|;

map { print "\n$column_header{$_}" } @column_index;

  print qq|
</tr>
|;

  # construct callback
  $customer = $form->{customer};
  $customer =~ s/&/_/g;
  $callback = $form->escape("$form->{script}?action=payments&transdatefrom=$form->{transdatefrom}&transdateto=$form->{transdateto}&open=$form->{open}&path=$form->{path}&login=$form->{login}&password=$form->{password}&sort=$form->{sort}&invnumber=$form->{invnumber}&ordnumber=$form->{ordnumber}&customer=$customer");
 
 
  foreach $key (sort keys %{$form->{paidaccount}}) {
    $paidaccounts .= qq|<option>$form->{paidaccount}{$key}{accno}--$form->{paidaccount}{$key}{description}\n|;
  }


  foreach $ar (@{ $form->{AR} }) {
    $i++;

    $j++; $j %= 2;
    print "<tr class=listrow$j>";
    
    $column_data{transdate} = qq|<td>$ar->{transdate}</td>|;

    $module = ($ar->{invoice}) ? "is.pl" : $form->{script};
    
    $column_data{invnumber} = "<td><a href=$module?action=edit&id=$ar->{id}&path=$form->{path}&login=$form->{login}&password=$form->{password}&callback=$callback>$ar->{invnumber}</a></td>";

    $column_data{ordnumber} = "<td>$ar->{ordnumber}&nbsp;</td>";
    
    $amount = $form->format_amount(\%myconfig, $ar->{amount} / $ar->{exchangerate}, 2, "&nbsp;");
    
    
    $column_data{name} = "<td>$ar->{name}</td>";
    $column_data{amount} = "<td align=right>$amount</td>";
    $column_data{currency} = "<td>$ar->{currency}&nbsp;</td>";
    $column_data{exchangerate} = ($ar->{currency} eq $form->{defaultcurrency}) ? "<td>&nbsp;</td>" : "<td>$ar->{exchangerate}</td>";
    $column_data{source} = "<td>&nbsp;</td>";

    map { print "\n$column_data{$_}" } @column_index;

    print qq|
</tr>
<tr>
|;


    # list all the payments
    $totalpaid = 0;
    $column_data{invnumber} = qq|<th>|.$locale->text('Received').qq|</th>|;
    $column_data{ordnumber} = qq|<td>&nbsp;</td>|;

    foreach $ref (@{ $ar->{payments} }) {
      $j++; $j %= 2;

      print "<tr class=listrow$j>";
      
      $column_data{transdate} = qq|<td>$ref->{transdate}</td>|;
      $column_data{name} = qq|<td>$form->{paidaccount}{$ref->{accno}}{description}</td>|;
      $column_data{amount} = qq|<td align=right>|.$form->format_amount(\%myconfig, $ref->{amount} * -1, 2).qq|</td>|;
      $column_data{currency} = qq|<td>$ar->{currency}</td>|;
      $column_data{exchangerate} = ($ar->{currency} eq $form->{defaultcurrency}) ? "<td>&nbsp;</td>" : "<td>$ref->{exchangerate}</td>";
      $column_data{source} = qq|<td>$ref->{source}&nbsp;</td>|;

      map { print "\n$column_data{$_}" } @column_index;

      print qq|</tr>\n|;
      
      $column_data{invnumber} = qq|<td>&nbsp;</td>|;

      $totalpaid += ($ref->{amount} * -1);
    }
    
    
    print "</tr><tr>\n";
    
    # arrange data for payment input
    $column_data{transdate} = qq|<td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="datepaid_$i" size=11></td>|;
    
    $column_data{name} = qq|<td><select  onkeypress="selectKeyPress();" onkeydown="setsubmit(this);selectKeyDown();" onblur="clr();" onfocus="clr();"  name="accno_$i">$paidaccounts</select></td>|;
    
    $column_data{amount} = qq|<td align=right><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="paid_$i" size=9></td>|;
    
    $column_data{source} = qq|<td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="source_$i" size=10></td>|;
    
    $column_data{exchangerate} = ($ar->{currency} eq $form->{defaultcurrency}) ? qq|<td>&nbsp;</td>| : qq|<td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="exchangerate_$i" size=10></td>|;
    
    map { print "\n$column_data{$_}" } @column_index;

    print qq|
</tr>

<input type=hidden name="currency_$i" value=$ar->{currency}>
<input type=hidden name="iexch_$i" value=$ar->{exchangerate}>
<input type=hidden name="totalpaid_$i" value=$totalpaid>
<input type=hidden name="id_$i" value=$ar->{id}>
<input type=hidden name="AR_$i" value=$ar->{AR_account}>

<tr><td colspan=8><hr size=3 noshade></td></tr>
|;

  }
  
  print qq|
</table>

<input type=hidden name=rowcount value=$i>

<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>
<input type=hidden name=password value=$form->{password}>

<br>
<input class=submit type=submit name=action value="|.$locale->text('Process Payments').qq|">

</form>

<p>|.$locale->text('Click on table headers to sort table').qq|
<br>|.$locale->text('Click on invoice number to edit transaction')

.qq|

</body>
</html>
|;

}


sub process_payments {

  $closedto = $form->datetonum($form->{closedto}, \%myconfig);
  
  $msg = $locale->text('Cannot post transaction for a closed period!');
  
  # check closedto
  for $i (1 .. $form->{rowcount}) {
    if ($form->{"datepaid_$i"}) {
      $datepaid = $form->datetonum($form->{"datepaid_$i"}, \%myconfig);
      $form->error($msg) if ($datepaid <= $closedto);
    }
  }

      
  # construct callback
  $form->{callback} = "$form->{script}?action=search&nextsub=payments&path=$form->{path}&login=$form->{login}&password=$form->{password}";

  AR->process_payments(\%myconfig, \%$form);
  $form->redirect;

}

