#=====================================================================
# SQL-Ledger Accounting
# Copyright (c) 2001
#
#  Author: Dieter Simader
#   Email: dsimader@sql-ledger.org
#     Web: http://www.sql-ledger.org
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#======================================================================
#
# Genereal Ledger
#
#======================================================================


use SL::dataentry2;
use SL::GL;

1;

sub add {
   #####australia modify
$form->{debit_credit}="<option>Debit\n<option>Credit";

if(!$form->{page} ||	!$form->{pagerows}){
	 $form->{pagerows}=5;
	$form->{page}=1;
 }
 
 if($form->{transdate}){
 $lastbatch = $form->{batch};
 #$lastdate = $form->{transdate};
 }
  # we use this only to set a default date
  GL->transaction(\%myconfig, \%$form);

if($lastdate){
 #$form->{transdate}=$lastdate;
$form->{batch}=$lastbatch;
}



  #$form->{title} = "Add";

  $form->{callback} = "$form->{script}?action=add&path=$form->{path}&title=$form->{title}&login=$form->{login}&password=$form->{password}&arap=$form->{arap}&debit_credit1=$form->{debit_credit1}&sourceheading=$form->{sourceheading}";

  map { $form->{$_} =~ s/\\/ /g } qw(debit_credit1);

 if($form->{transdate}){
 $lastbatch = $form->{batch};
 $lastdate = $form->{transdate};
 }
  # we use this only to set a default date

  dataentry2->transaction(\%myconfig, \%$form);
$form->{"chart3"} = $form->{"chart2"};

if($lastdate){
 $form->{transdate}=$lastdate;
$form->{batch}=$lastbatch;
}

  $form->{rowcount} = 1;
   #  $form->{debit_credit1}= "<option selected>Debit<option>Credit";
  &display_form;

}

sub edit {
  #   GL->transaction(\%myconfig, \%$form);
    #####australia modify
$form->{debit_credit}="<option>Debit\n<option>Credit";

 if(!$form->{page} ||	!$form->{pagerows}){
	 $form->{pagerows}=5;
	$form->{page}=1;
 }

	
  dataentry2->transaction(\%myconfig, \%$form);
    $form->{"chart3"} = $form->{"chart2"};

  $form->{locked} = ($form->datetonum($form->{transdate}, \%myconfig) <= $form->datetonum($form->{closedto}, \%myconfig));

  $form->{title} = "Edit Quick Entry";

#Set the Source Prefix while in edit mode
  $form->{source} = "MBB-";
  
    map { $form->{$_} =~ s/\\/ /g } qw(debit_credit1);

#  my $debit_credit;

  if($form->{"type"} == 1){
     $form->{debit_credit1}= "Debit";
#  $form->dberror($form->{"type"});
}else{
     $form->{debit_credit1}= "Credit";
#$form->dberror($debit_credit);

  }

  $form->{"main_accno"} =$form->{"accno"}."--".$form->{"description"};
  $i = 1;

&form_header;

  foreach $ref (@{ $form->{dataentry2} }) {
    $form->{"accno_$i"} = $ref->{accno}."--".$ref->{desc};
    $form->{"source_$i"} = $ref->{source};
    $form->{"description_$i"} = $ref->{description};
    $form->{"transdate_$i"} = $ref->{transdate};
    $form->{"transno_$i"} = $ref->{transno};
    $form->{"subtransno_$i"} = $ref->{subtransno};
    $form->{"sub_$i"} = $ref->{sub};
    $form->{"proj_$i"} = $ref->{proj};
    $form->{"amount_$i"} = $ref->{amount} * $form->{"type"};

   #####australia modify

if(($i > (($form->{page}-1)*$form->{pagerows})) && ($i <= ($form->{page} *$form->{pagerows}))){
	&form_row($i);
}else{
	&form_row_hidden($i);
}
  
  $i++;
  

  }
   #####australia modify

if(($i >= (($form->{page}-1)*$form->{pagerows})) && ($i <= (($form->{page}*$form->{pagerows})+ $form->{pagerows}))){
	&form_row($i);
}else{
	&form_row_hidden($i);
}


  &form_footer;
}

sub display_form {

  &form_header;
  $form->{rowcount}++;
  #if($form->{rowcount} <3){
  #$form->{rowcount}=2;
  #}
  

  for $i (1 .. $form->{rowcount}) {
    if($i == 1){
    	$form->{"transtype_$i"}=$form->{"transtype"};
	if(!$form->{"transno_$i"}){
    		$form->{"transno_$i"}=$form->{"transno"};
	}
	if(!$form->{"transdate_$i"}){
    		$form->{"transdate_$i"}=$form->{"transdate"};
	}
	$form->{"invnumber_$i"}=$form->{prefix}.1;
 #	$form->{"invnumber_$i"}++;
   }
    if($i == $form->{rowcount}){
    	$y = $form->{rowcount}-1;
    	$form->{"transtype_$i"}=$form->{"transtype_$y"};
    	$form->{"accno_$i"}=$form->{"accno_$y"};
   #####australia modify
    	$form->{"accno1_$i"}=$form->{"accno_$y"};
   ( $form->{"accno1_$i"},$null ) = split /--/, $form->{"accno1_$i"};
    $form->{"batch_$i"}=$form->{"batch_$y"};
	$form->{"transno_$i"}=$form->{"transno_$y"};
    	$form->{"transno_$i"}++;
    	$form->{"subtransno_$i"}=$form->{"subtransno_$y"};
    	$form->{"transdate_$i"}=$form->{"transdate_$y"};
     	$form->{"invnumber_$i"}=$form->{"invnumber_$y"};
    	$form->{"description_$i"}=$form->{"description_$y"};
	$form->{"invnumber_$i"}++;

   }
if(!$form->{"source_$i"}){
$form->{"source_$i"}=$form->{"source"};
}
 

   #####australia modify

if(($i > (($form->{page}-1)*$form->{pagerows})) && ($i <= ($form->{page} *$form->{pagerows}))){
	&form_row($i);
}else{
	&form_row_hidden($i);
}
  
  }

 # if(!$form->{"nextfocus"}){

#	$form->{"nextfocus"}  = "transno_$form->{rowcount}";
 #}
  &form_footer;

}



sub form_row {
 my $i = shift;

  my $chart;
  
  $form->{"chart2"} =~ s/\(/;brak/g;

$form->{"chart2"} =~ s/\)/;2brak/g;

$form->{"chart2"} =~ s/\[/;brek/g;

$form->{"chart2"} =~ s/\]/;2brek/g;
  $form->{"accno_$i"} =~ s/\(/;brak/g;

$form->{"accno_$i"} =~ s/\)/;2brak/g;

$form->{"accno_$i"} =~ s/\[/;brek/g;

$form->{"accno_$i"} =~ s/\]/;2brek/g;


#$form->dberror($form->{"accno_$i"});
#if((!$form->{"amount_$i"}) ){
    $form->{"chart2"} = $form->{"chart3"};
    $form->{"chart2"} =~ s/ selected//;
    $form->{"chart2"} =~ s/option value='$form->{"accno_$i"}'>\Q$form->{"accno_$i"}\E/option selected value='$form->{"accno_$i"}'>$form->{"accno_$i"}/;
#}else{
#$form->{"chart2"} = qq|<option value='$form->{"accno_$i"}'>$form->{"accno_$i"}|;
#}



   $form->{"chart2"} =~ s/;brak/\(/g;

$form->{"chart2"} =~ s/;2brak/\)/g;

   $form->{"chart2"} =~ s/;brek/\[/g;

$form->{"chart2"} =~ s/;2brek/\]/g;
   $form->{"accno_$i"} =~ s/;brak/\(/g;

$form->{"accno_$i"} =~ s/;2brak/\)/g;

   $form->{"accno_$i"} =~ s/;brek/\[/g;

$form->{"accno_$i"} =~ s/;2brek/\]/g;


$total +=$form->{"amount_$i"};
 # <td><select  onkeypress="selectKeyPress();" onkeydown="setsubmit(this);selectKeyDown();" onblur="clr();" onfocus="clr();"  name="accno_$i"  onChange="this.form.accno1_$i.value=this.options[this.selectedIndex].value">$form->{"chart2"}</select><input   TYPE="text" name="accno1_$i" size=20 value="$form->{"accno_$i"}"  ONKEYUP="autoComplete(this,this.form.accno_$i,'value',true)"><br><b>Description </b><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="description_$i" size=30 value='$form->{"description_$i"}'></td>
  print qq|<tr valign=bottom>
  <td>$i</td>
  <td nowrap ><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="transno_$i"  size=4 value="$form->{"transno_$i"}"><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="subtransno_$i"  size=2 value="$form->{"subtransno_$i"}"></td>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="transdate_$i" size=10 value=$form->{"transdate_$i"}></td>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="source_$i" size=10 value=$form->{"source_$i"}></td>
  <td><select  onkeypress="selectKeyPress();" onkeydown="setsubmit(this);selectKeyDown();" onblur="clr();" onfocus="clr();"  name="accno_$i"  onChange="this.form.accno1_$i.value=this.options[this.selectedIndex].value">$form->{"chart2"}</select><br><b>Description </b><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="description_$i" size=30 value='$form->{"description_$i"}'></td>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="amount_$i" size=6 value=$form->{"amount_$i"}></td>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="sub_$i" size=4 value=$form->{"sub_$i"}></td>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="proj_$i" size=4 value=$form->{"proj_$i"}></td>

</tr>
<input type=hidden name=rowcount value=$i>


|;


}
   #####australia modify

sub form_row_hidden {
 my $i = shift;

  my $chart;
  
  $form->{"chart2"} =~ s/\(/;brak/g;

$form->{"chart2"} =~ s/\)/;2brak/g;

$form->{"chart2"} =~ s/\[/;brek/g;

$form->{"chart2"} =~ s/\]/;2brek/g;
  $form->{"accno_$i"} =~ s/\(/;brak/g;

$form->{"accno_$i"} =~ s/\)/;2brak/g;

$form->{"accno_$i"} =~ s/\[/;brek/g;

$form->{"accno_$i"} =~ s/\]/;2brek/g;






   $form->{"chart2"} =~ s/;brak/\(/g;

$form->{"chart2"} =~ s/;2brak/\)/g;

   $form->{"chart2"} =~ s/;brek/\[/g;

$form->{"chart2"} =~ s/;2brek/\]/g;
   $form->{"accno_$i"} =~ s/;brak/\(/g;

$form->{"accno_$i"} =~ s/;2brak/\)/g;

   $form->{"accno_$i"} =~ s/;brek/\[/g;

$form->{"accno_$i"} =~ s/;2brek/\]/g;


$total +=$form->{"amount_$i"};
 # <td><select  onkeypress="selectKeyPress();" onkeydown="setsubmit(this);selectKeyDown();" onblur="clr();" onfocus="clr();"  name="accno_$i"  onChange="this.form.accno1_$i.value=this.options[this.selectedIndex].value">$form->{"chart2"}</select><input   TYPE="text" name="accno1_$i" size=20 value="$form->{"accno_$i"}"  ONKEYUP="autoComplete(this,this.form.accno_$i,'value',true)"><br><b>Description </b><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="description_$i" size=30 value='$form->{"description_$i"}'></td>
  print qq|

  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="transno_$i"  type=hidden value="$form->{"transno_$i"}"><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="subtransno_$i"  type=hidden value="$form->{"subtransno_$i"}">
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="transdate_$i" type=hidden value=$form->{"transdate_$i"}>
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="source_$i" type=hidden value="$form->{"source_$i"}">
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="accno_$i"  type=hidden value="$form->{"accno_$i"}"><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="description_$i" type=hidden value='$form->{"description_$i"}'>
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="amount_$i" type=hidden value=$form->{"amount_$i"}>
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="sub_$i" type=hidden value=$form->{"sub_$i"}>
  <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="proj_$i" type=hidden value=$form->{"proj_$i"}>


<input type=hidden name=rowcount value=$i>


|;


}


sub form_header {
 my $chart;
 my $total;
$total=0;
 


  $title = $form->{title};
 # $form->{title} = $locale->text("$title ");

# $locale->text('Add General Ledger Transaction')
# $locale->text('Edit General Ledger Transaction')

  map { $form->{$_} =~ s/"/&quot;/g } qw(source description chart);

  if (($rows = $form->numtextrows($form->{description}, 50)) > 1) {
    $description = qq|<textarea name=description rows=$rows cols=50 wrap=soft>$form->{description}</textarea>|;
  } else {
    $description = qq|<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=description size=50 value="$form->{description}">|;
  }


  $colspan = 8;

if(!$form->{nextfocus}){
	$form->{nextfocus}="transtype";
}

  $form->header;
#$form->dberror($form->{"main_accno"});
    #####australia modify
    if(!$form->{sourceheading}){
	    $form->{sourceheading}=$locale->text('Source');
    }
    $form->{debit_credit} =~ s/ selected//;
    $form->{debit_credit} =~ s/option>\Q$form->{"debit_credit1"}\E/option selected>$form->{"debit_credit1"}/;
    
    $form->{"chart2"} =~ s/ selected//;
    $form->{"chart2"} =~ s/option value='$form->{"main_accno"}'>\Q$form->{"main_accno"}\E/option selected value='$form->{"main_accno"}'>$form->{"main_accno"}/;

     #####australia modify  -- look at the html content

  print qq|
<script>
<!--
function stb(){document.myform.$form->{nextfocus}.focus();}

function autoComplete (field, select, property, forcematch) {
	var found = false;
	for (var i = 0; i < select.options.length; i++) {
	if (select.options[i][property].toUpperCase().indexOf(field.value.toUpperCase()) == 0) {
		found=true; break;
		}
	}
	if (found) { select.selectedIndex = i; }
	else { select.selectedIndex = -1; }
	if (field.createTextRange) {
		if (forcematch && !found) {
			field.value=field.value.substring(0,field.value.length-1); 
			return;
			}
		var cursorKeys ="8;46;37;38;39;40;33;34;35;36;45;";
		if (cursorKeys.indexOf(event.keyCode+";") == -1) {
			var r1 = field.createTextRange();
			var oldValue = r1.text;
			var newValue = found ? select.options[i][property] : oldValue;
			if (newValue != field.value) {
				field.value = newValue;
				var rNew = field.createTextRange();
				rNew.moveStart('character', oldValue.length) ;
				rNew.select();
				}
			}
		}
	}
	
// -->
</script>

<body bgcolor=ffffff onLoad=stb()>

<form method=post name=myform action=$form->{script}>

<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=id type=hidden value=$form->{id}>
<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=accno type=hidden value=$form->{accno}>
<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=salesaccno type=hidden value=$form->{salesaccno}>
<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=cashaccno type=hidden value=$form->{cashaccno}>
<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=in_out type=hidden value=$form->{in_out}>
<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=customer_number type=hidden value=$form->{customer_number}>
<input type=hidden name=arap value=$form->{arap}>
<input type=hidden name=prefix value=$form->{prefix}>
<input type=hidden name=title value="$form->{title}">
<input type=hidden name=page value="$form->{page}">
<input type=hidden name=pagerows value="$form->{pagerows}">
<input type=hidden name=nextfocus value=$form->{nextfocus}>
<input type=hidden name=keys >

<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=chart type=hidden value="$form->{chart}">
<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=chart2 type=hidden value="$form->{chart2}">
<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=chart3 type=hidden value="$form->{chart2}">
<input type=hidden name=closedto value=$form->{closedto}>
<input type=hidden name=locked value=$form->{locked}>
<input type=hidden name=title value="$title">
<input type=hidden name=debit_credit value="$form->{debit_credit}">

<input type=hidden name=sourceheading value="$form->{sourceheading}">

<table border=1>
<tr><th class=listtop bgcolor=000000 colspan=$colspan><font color=ffffff>$form->{title}</font></th></tr>

<tr><td colspan=$colspan>
<table border=0>


<tr>
 <th align=right>|.$locale->text('Type').qq|</th>
  <td><select  onkeypress="selectKeyPress();" onkeydown="setsubmit(this);selectKeyDown();" onblur="clr();" onfocus="clr();"  name="debit_credit1">$form->{debit_credit}</td>
</tr>
<tr>
<th align=right>|.$locale->text('Batch').qq|</th>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="transtype" size=5 value="$form->{"transtype"}">-<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="batch" size=5 value="$form->{"batch"}"></td>
<th align=right>|.$locale->text('Source Prefix').qq|</th>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="source" size=10 value="$form->{"source"}"></td>
</tr>
<tr>
 <th align=right>|.$locale->text('Account').qq|</th>
  <td><select  onkeypress="selectKeyPress();" onkeydown="setsubmit(this);selectKeyDown();" onblur="clr();" onfocus="clr();"  name="main_accno"  onChange="this.form.main_accno1.value=this.options[this.selectedIndex].value">$form->{"chart2"}</select></td>
</tr>


</table>
</td></tr>

<tr class=listheading bgcolor=336666>

  <th><font color=ffffff>|.$locale->text('No.').qq|</th>
  <th><font color=ffffff>|.$locale->text('Trans No.').qq|</th>
  <th><font color=ffffff>|.$locale->text('Date').qq|($myconfig{dateformat})</th>
  <th><font color=ffffff>|.$form->{sourceheading}.qq|</th>
  <th><font color=ffffff>|.$locale->text('Account.').qq|</th>
  <th><font color=ffffff>|.$locale->text('Amount').qq|</th>
  <th><font color=ffffff>|.$locale->text('Sub').qq|</th>
  <th><font color=ffffff>|.$locale->text('Proj. No.').qq|</th>

</tr>
|;

}


sub form_footer {

  print qq|
<tr class=listsubtotal bgcolor=336666>

  <th><font color=ffffff>&nbsp;</th>
  <th><font color=ffffff>&nbsp;</th>
  <th><font color=ffffff>&nbsp;</th>
  <th><font color=ffffff>&nbsp;</th>
  <th><font color=ffffff>&nbsp;</th>
  <th align=right><font color=ffffff>$total</th>
  <th><font color=ffffff>&nbsp;</th>
  <th><font color=ffffff>&nbsp;</th>

</tr>

<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>
<input type=hidden name=password value=$form->{password}>

<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=callback type=hidden value="$form->{callback}">

</table>
			  <input type=hidden name=action value=update_form2>

<br>
|;


  $transdate = $form->datetonum($form->{transdate}, \%myconfig);
  $closedto = $form->datetonum($form->{closedto}, \%myconfig);

  if ($form->{id}) {
    print qq|<input class=submit type=submit name=action value="|.$locale->text('Update Form').qq|">|;

		####admend 2 sections as necessary
		print qq|<br>|;
		if(!$i){
			$i=$form->{rowcount};
		}                                                                      
		
   #####australia modify
		for $j (1 ..(( $i/$form->{pagerows})+1) ) {
			 # <a  href=dataentry2.pl?action=update_form&page=$j&pagerows=$form->{pagerows}&id=$form->{"id"}&path=$form->{path}&login=$form->{login}&password=$form->{password}&callback=$callback>Page $j</a>
			  print qq|
			  <input class=submit type=submit name=page value=' $j '>	  
			  |;
		  }
  		print qq|<br>|;

  
    if (!$form->{revtrans}) {
    #  if (!$form->{locked}) {
	print qq|
	<input class=submit type=submit name=action value="|.$locale->text('Post Transaction').qq|">
	<input class=submit type=submit name=action value="|.$locale->text('Delete Transaction').qq|">
|;
      }
   # }

    if ($transdate > $closedto) {
      print qq|
      <input class=submit type=submit name=action value="|.$locale->text('Post As New Transaction').qq|">
|;
    }

  } else {
    if ($transdate > $closedto) {
      print qq|<input class=submit type=submit name=action value="|.$locale->text('Update Form').qq|">|;

		    #adjust above same section 
		print qq|<br>|;
		if(!$i){
			$i=$form->{rowcount};
		}                                                                      
		
   #####australia modify
		for $j (1 ..(( $i/$form->{pagerows})+1) ) {
			 # <a  href=dataentry2.pl?action=update_form&page=$j&pagerows=$form->{pagerows}&id=$form->{"id"}&path=$form->{path}&login=$form->{login}&password=$form->{password}&callback=$callback>Page $j</a>
			  print qq|
			  <input class=submit type=submit name=page value=' $j '>	  
			  |;
		  }
		print qq|<br>|;
			print qq|	<input class=submit type=submit name=action value="|.$locale->text('Post Transaction').qq|">|;
    
    
    }
  }


  print "</form>

</body>
</html>
";

}
   #####australia modify

sub update_form {
  $form->{page}=$form->{rowcount}/$form->{pagerows};
  ($form->{page},$dec) = split(/\./,$form->{page});
  if($dec >=0){
	  $form->{page}++;	  
  }
  
&update_form2;
}
   #####australia modify

sub update_form2 {
#$form->dberror($form->{page});

if($form->{transdate}){
 $lastbatch = $form->{batch};
 $lastdate = $form->{transdate};
 }
  # we use this only to set a default date
  dataentry2->transaction(\%myconfig, \%$form);

if($lastdate){
 $form->{transdate}=$lastdate;
$form->{batch}=$lastbatch;
}


  @a = ();
  $count = 0;
  @flds = (qw(transno transtype batch subtransno transdate invnumber amount ));

  for $i (1 .. $form->{rowcount}) {
    unless ( ($form->{"amount_$i"} eq "") && ($i > 1)) {
      # take accno apart
    #  if($form->{"accno1_$i"}){
	#($form->{"accno_$i"}) =($form->{"accno1_$i"})
    #  }else{
     # ($form->{"accno_$i"}) = split(/--/, $form->{"accno_$i"});
    # }

      push @a, {};
      $j = $#a;

      map { $a[$j]->{$_} = $form->{"${_}_$i"} } @flds;
      $count++;
    }
  }

  for $i (1 .. $count) {
    $j = $i - 1;
    map { $form->{"${_}_$i"} = $a[$j]->{$_} } @flds;
    $form->{"selectaccno_$i"}= $form->{"accno_$j"};
  }


  for $i ($count + 1 .. $form->{rowcount}) {
    map { delete $form->{"${_}_$i"} } @flds;
  }
  
  $form->{rowcount} = $count;

	$x =$form->{rowcount}+1;
#	$form->{"nextfocus"}  = "transno_$x";

   	&display_form;

}

sub post_transaction {

  # check if there is something in source and date
  #$form->isblank("source", $locale->text('Source missing!'));
  #$form->isblank("transdate", $locale->text('Transaction Date missing!'));

  $rc = dataentry2->post_transaction(\%myconfig, \%$form);

  if ($rc == -1) {
    $form->error($locale->text("Cannot have a value in both Debit and Credit!"));
  }

  if ($rc == -2) {
    $form->error($locale->text("Customer or Vendor not found!"));
  }

  $form->isposted($rc);

}

sub delete_transaction {

  $form->header;

  print qq|
<body bgcolor=ffffff>

<form method=post action=$form->{script}>
|;

  map { $form->{$_} =~ s/"/&quot;/g } qw(source description chart);

  foreach $key (keys %$form) {
    print qq|<input type=hidden name=$key value="$form->{$key}">\n|;
  }

  print qq|
<h2><font color=blue>|.$locale->text('Confirm!').qq|</font></h2>

<h4>|.$locale->text('Are you sure you want to delete Transaction').qq| $form->{source}</h4>

<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=action class=submit type=submit value="|.$locale->text('Yes Delete Transaction').qq|">
</form>
|;

}

sub yes_delete_transaction {

  $form->isdeleted(dataentry2->delete_transaction(\%myconfig, \%$form));

}
