package tb;

$decimalplaces = 0;

sub trial_balance_details_all {
  my ($self, $myconfig, $form) = @_;

  my $dbh = $form->dbconnect($myconfig);

  # if there are any dates construct a where
  my $where = "1 = 1";
  my $where2 = "1 = 1";

  if ($form->{fromdate} || $form->{todate}) {
    if ($form->{fromdate}) {
      $where .= " AND acc_trans.transdate >= '$form->{fromdate}'";
      $where2 .= " AND acc_trans.transdate < '$form->{fromdate}'";
    }
    if ($form->{todate}) {
      $where .= " AND acc_trans.transdate <= '$form->{todate}'";
    }
  }

  # First we take the sum of debit and credit of each account in the period
              #  SELECT accno, description, charttype, category,sum(amount)*-1 as ob,
             # 0 AS debit,0 as credit,count(accno) as count
             # FROM chart, acc_trans
             # WHERE chart.id = acc_trans.chart_id 
	#	and $where2

         #     GROUP BY accno, description, charttype, category

	  #    union 
	      
  $query = qq|
  select accno,description,charttype,category,sum(ob)*-1 as ob ,sum(debit) as debit,sum(credit) as credit, sum(count) as count, sum(debit) - sum(credit) as total from (

	      
              SELECT accno, description, charttype, category,0 as ob,
              SUM(amount)*-1 AS debit,0 as credit,count(accno) as count
              FROM chart, acc_trans
              WHERE chart.id = acc_trans.chart_id and amount < 0
		and $where

              GROUP BY accno, description, charttype, category

		union
	      
              SELECT accno, description, charttype, category,0 as ob, 0 as debit,
              SUM(amount) AS credit,count(accno) as count
              FROM chart, acc_trans
              WHERE chart.id = acc_trans.chart_id and amount > 0
		and $where

              GROUP BY accno, description, charttype, category

		union
		
              SELECT accno, chart.description, charttype, category,SUM(amount) as ob,0 as debit,
              0 AS credit,count(accno)-1 as count
              FROM chart, acc_trans,gl
              WHERE chart.id = acc_trans.chart_id and  acc_trans.trans_id = gl.id
	      and (gl.transtype='OB' or gl.transtype='OU')
		and $where

              GROUP BY accno, chart.description, charttype, category
		union

              SELECT accno, chart.description, charttype, category,SUM(amount) as ob,0 as debit,
              0 AS credit,count(accno) as count
              FROM chart, acc_trans,ou
              WHERE chart.id = acc_trans.chart_id and  acc_trans.trans_id = ou.id
	      and (ou.transtype='OB' or ou.transtype='OU')
		and $where

              GROUP BY accno, chart.description, charttype, category
         UNION
	      SELECT accno, description, charttype, category, 0.0 as ob, 0.0 AS debit, 0.0 AS credit, 0.0 as count
	      FROM chart
	      WHERE charttype = 'H'
	      ORDER BY accno

) as foo group by accno, description,charttype,category
|;

  if ($form->{accounttype} eq 'gifi') {
    $query = qq|SELECT g.accno, g.description, c.charttype, c.category,
		SUM(a.amount) AS amount
		FROM gifi g, chart c, acc_trans a
		WHERE c.id = a.chart_id
      		AND c.gifi_accno = g.accno
		AND $where
		GROUP BY g.accno, g.description, c.charttype, c.category
	     UNION
		SELECT '' AS accno, '' AS description, 'A' AS charttype, 'X' AS category,
		SUM(a.amount) AS amount
		FROM chart c, acc_trans a
		WHERE c.id = a.chart_id
		AND c.gifi_accno = ''
		AND $where
	     UNION
		SELECT g.accno, g.description, c.charttype, c.category, 0.0 AS amount
		FROM gifi g, chart c
		WHERE c.charttype = 'H'
		AND c.gifi_accno = g.accno
		ORDER BY accno|;
  }

#$form->dberror($query);
  $sth = $dbh->prepare($query);
  $sth->execute || $form->dberror($query);

  # calculate the debit and credit in the period
  while (my $ref = $sth->fetchrow_hashref(NAME_lc)) {
    $ref->{debit} = $form->round_amount($ref->{debit}, 2);
    $ref->{credit} = $form->round_amount($ref->{credit}, 2);
  # next if ($ref->{charttype} eq 'A' && $ref->{amount} == 0);

    push @{ $form->{TB} }, $ref;
  }

  $sth->finish;
  $dbh->disconnect;

}

sub trial_balance_details_debit {
  my ($self, $myconfig, $form) = @_;

  my $dbh = $form->dbconnect($myconfig);

  # if there are any dates construct a where
  my $where = "1 = 1";

  if ($form->{fromdate} || $form->{todate}) {
    if ($form->{fromdate}) {
      $where .= " AND acc_trans.transdate >= '$form->{fromdate}'";
    }
    if ($form->{todate}) {
      $where .= " AND acc_trans.transdate <= '$form->{todate}'";
    }
  }

  # First we take the sum of debit and credit of each account in the period
  $query = qq|
  select accno,description,charttype,category,sum(ob)*-1 as ob ,sum(debit) as debit,sum(credit) as credit, sum(count) as count, sum(debit) - sum(credit) as total from (
              SELECT accno, description, charttype, category,0 as ob,
              SUM(amount)*-1 AS debit,0 as credit,count(accno) as count
              FROM chart, acc_trans
              WHERE chart.id = acc_trans.chart_id and amount < 0 and chart.category='D'
		and $where

              GROUP BY accno, description, charttype, category

		union
	      
              SELECT accno, description, charttype, category,0 as ob, 0 as debit,
              SUM(amount) AS credit,count(accno) as count
              FROM chart, acc_trans
              WHERE chart.id = acc_trans.chart_id and amount > 0 and chart.category='D'
		and $where

              GROUP BY accno, description, charttype, category

		union
		
              SELECT accno, chart.description, charttype, category,SUM(amount) as ob,0 as debit,
              0 AS credit,count(accno)-1 as count
              FROM chart, acc_trans,gl
              WHERE chart.id = acc_trans.chart_id and  acc_trans.trans_id = gl.id and chart.category='D'
	      and (gl.transtype='OB' or gl.transtype='OU')
		and $where

              GROUP BY accno, chart.description, charttype, category
		union

              SELECT accno, chart.description, charttype, category,SUM(amount) as ob,0 as debit,
              0 AS credit,count(accno) as count
              FROM chart, acc_trans,ou
              WHERE chart.id = acc_trans.chart_id and  acc_trans.trans_id = ou.id and chart.category='D'
	      and (ou.transtype='OB' or ou.transtype='OU')
		and $where

              GROUP BY accno, chart.description, charttype, category
         UNION
	      SELECT accno, description, charttype, category, 0.0 as ob, 0.0 AS debit, 0.0 AS credit, 0.0 as count
	      FROM chart
	      WHERE charttype = 'H' and chart.category='D'
	      ORDER BY accno

) as foo group by accno, description,charttype,category
|;

  if ($form->{accounttype} eq 'gifi') {
    $query = qq|SELECT g.accno, g.description, c.charttype, c.category,
		SUM(a.amount) AS amount
		FROM gifi g, chart c, acc_trans a
		WHERE c.id = a.chart_id
      		AND c.gifi_accno = g.accno and chart.category='D'
		AND $where
		GROUP BY g.accno, g.description, c.charttype, c.category
	     UNION
		SELECT '' AS accno, '' AS description, 'A' AS charttype, 'X' AS category,
		SUM(a.amount) AS amount
		FROM chart c, acc_trans a
		WHERE c.id = a.chart_id and chart.category='D'
		AND c.gifi_accno = ''
		AND $where
	     UNION
		SELECT g.accno, g.description, c.charttype, c.category, 0.0 AS amount
		FROM gifi g, chart c
		WHERE c.charttype = 'H' and chart.category='D'
		AND c.gifi_accno = g.accno
		ORDER BY accno|;
  }

#$form->dberror($query);
  $sth = $dbh->prepare($query);
  $sth->execute || $form->dberror($query);

  # calculate the debit and credit in the period
  while (my $ref = $sth->fetchrow_hashref(NAME_lc)) {
    $ref->{debit} = $form->round_amount($ref->{debit}, 2);
    $ref->{credit} = $form->round_amount($ref->{credit}, 2);
  # next if ($ref->{charttype} eq 'A' && $ref->{amount} == 0);

    push @{ $form->{TB} }, $ref;
  }

  $sth->finish;
  $dbh->disconnect;

}

sub trial_balance_details_credit {
  my ($self, $myconfig, $form) = @_;

  my $dbh = $form->dbconnect($myconfig);

  # if there are any dates construct a where
  my $where = "1 = 1";

  if ($form->{fromdate} || $form->{todate}) {
    if ($form->{fromdate}) {
      $where .= " AND acc_trans.transdate >= '$form->{fromdate}'";
    }
    if ($form->{todate}) {
      $where .= " AND acc_trans.transdate <= '$form->{todate}'";
    }
  }

  # First we take the sum of debit and credit of each account in the period
  $query = qq|
  select accno,description,charttype,category,sum(ob)*-1 as ob ,sum(debit) as debit,sum(credit) as credit, sum(count) as count, sum(debit) - sum(credit) as total from (
              SELECT accno, description, charttype, category,0 as ob,
              SUM(amount)*-1 AS debit,0 as credit,count(accno) as count
              FROM chart, acc_trans
              WHERE chart.id = acc_trans.chart_id and amount < 0 and chart.category='C'
		and $where

              GROUP BY accno, description, charttype, category

		union
	      
              SELECT accno, description, charttype, category,0 as ob, 0 as debit,
              SUM(amount) AS credit,count(accno) as count
              FROM chart, acc_trans
              WHERE chart.id = acc_trans.chart_id and amount > 0 and chart.category='C'
		and $where

              GROUP BY accno, description, charttype, category

		union
		
              SELECT accno, chart.description, charttype, category,SUM(amount) as ob,0 as debit,
              0 AS credit,count(accno)-1 as count
              FROM chart, acc_trans,gl
              WHERE chart.id = acc_trans.chart_id and  acc_trans.trans_id = gl.id and chart.category='C'
	      and (gl.transtype='OB' or gl.transtype='OU')
		and $where

              GROUP BY accno, chart.description, charttype, category
		union

              SELECT accno, chart.description, charttype, category,SUM(amount) as ob,0 as debit,
              0 AS credit,count(accno) as count
              FROM chart, acc_trans,ou
              WHERE chart.id = acc_trans.chart_id and  acc_trans.trans_id = ou.id and chart.category='C'
	      and (ou.transtype='OB' or ou.transtype='OU')
		and $where

              GROUP BY accno, chart.description, charttype, category
         UNION
	      SELECT accno, description, charttype, category, 0.0 as ob, 0.0 AS debit, 0.0 AS credit, 0.0 as count
	      FROM chart
	      WHERE charttype = 'H' and chart.category='C'
	      ORDER BY accno

) as foo group by accno, description,charttype,category
|;

  if ($form->{accounttype} eq 'gifi') {
    $query = qq|SELECT g.accno, g.description, c.charttype, c.category,
		SUM(a.amount) AS amount
		FROM gifi g, chart c, acc_trans a
		WHERE c.id = a.chart_id
      		AND c.gifi_accno = g.accno and chart.charttype='C'
		AND $where
		GROUP BY g.accno, g.description, c.charttype, c.category
	     UNION
		SELECT '' AS accno, '' AS description, 'A' AS charttype, 'X' AS category,
		SUM(a.amount) AS amount
		FROM chart c, acc_trans a
		WHERE c.id = a.chart_id and chart.category='C'
		AND c.gifi_accno = ''
		AND $where
	     UNION
		SELECT g.accno, g.description, c.charttype, c.category, 0.0 AS amount
		FROM gifi g, chart c
		WHERE c.charttype = 'H' and chart.category='C'
		AND c.gifi_accno = g.accno
		ORDER BY accno|;
  }

#$form->dberror($query);
  $sth = $dbh->prepare($query);
  $sth->execute || $form->dberror($query);

  # calculate the debit and credit in the period
  while (my $ref = $sth->fetchrow_hashref(NAME_lc)) {
    $ref->{debit} = $form->round_amount($ref->{debit}, 2);
    $ref->{credit} = $form->round_amount($ref->{credit}, 2);
  # next if ($ref->{charttype} eq 'A' && $ref->{amount} == 0);

    push @{ $form->{TB} }, $ref;
  }

  $sth->finish;
  $dbh->disconnect;

}

sub trial_balance_details_not_debit_credit {
  my ($self, $myconfig, $form) = @_;

  my $dbh = $form->dbconnect($myconfig);

  # if there are any dates construct a where
  my $where = "1 = 1";

  if ($form->{fromdate} || $form->{todate}) {
    if ($form->{fromdate}) {
      $where .= " AND acc_trans.transdate >= '$form->{fromdate}'";
    }
    if ($form->{todate}) {
      $where .= " AND acc_trans.transdate <= '$form->{todate}'";
    }
  }

  # First we take the sum of debit and credit of each account in the period
  $query = qq|
  select accno,description,charttype,category,sum(ob)*-1 as ob ,sum(debit) as debit,sum(credit) as credit, sum(count) as count, sum(debit) - sum(credit) as total from (
              SELECT accno, description, charttype, category,0 as ob,
              SUM(amount)*-1 AS debit,0 as credit,count(accno) as count
              FROM chart, acc_trans
              WHERE chart.id = acc_trans.chart_id and amount < 0 and chart.category<>'C' and chart.category <>'D'
		and $where

              GROUP BY accno, description, charttype, category

		union
	      
              SELECT accno, description, charttype, category,0 as ob, 0 as debit,
              SUM(amount) AS credit,count(accno) as count
              FROM chart, acc_trans
              WHERE chart.id = acc_trans.chart_id and amount > 0 and chart.category<>'C' and chart.category <>'D'
		and $where

              GROUP BY accno, description, charttype, category

		union
		
              SELECT accno, chart.description, charttype, category,SUM(amount) as ob,0 as debit,
              0 AS credit,count(accno)-1 as count
              FROM chart, acc_trans,gl
              WHERE chart.id = acc_trans.chart_id and  acc_trans.trans_id = gl.id and chart.category<>'C' and chart.category <>'D'
	      and (gl.transtype='OB' or gl.transtype='OU')
		and $where

              GROUP BY accno, chart.description, charttype, category
		union

              SELECT accno, chart.description, charttype, category,SUM(amount) as ob,0 as debit,
              0 AS credit,count(accno) as count
              FROM chart, acc_trans,ou
              WHERE chart.id = acc_trans.chart_id and  acc_trans.trans_id = ou.id and chart.category<>'C' and chart.category <>'D'
	      and (ou.transtype='OB' or ou.transtype='OU')
		and $where

              GROUP BY accno, chart.description, charttype, category
         UNION
	      SELECT accno, description, charttype, category, 0.0 as ob, 0.0 AS debit, 0.0 AS credit, 0.0 as count
	      FROM chart
	      WHERE charttype = 'H' and chart.category<>'C' and chart.category <>'D'
	      
	 union
	 

	 select (select chart.accno from chart where chart.category='C' and  charttype='H') as accno,(select chart.description from chart where chart.category='C' and  charttype='H') as description,'A','C', sum(ob),sum(debit),sum(credit),sum(count) from 
	 (
		  select accno,description,charttype,category,sum(ob) as ob ,sum(debit) as debit,sum(credit) as credit, sum(count) as count from (
			      SELECT accno, description, charttype, category,0 as ob,
			      SUM(amount)*-1 AS debit,0 as credit,count(accno) as count
			      FROM chart, acc_trans
			      WHERE chart.id = acc_trans.chart_id and amount < 0 and chart.category='C'
				and $where
		
			      GROUP BY accno, description, charttype, category
		
				union
			      
			      SELECT accno, description, charttype, category,0 as ob, 0 as debit,
			      SUM(amount) AS credit,count(accno) as count
			      FROM chart, acc_trans
			      WHERE chart.id = acc_trans.chart_id and amount > 0 and chart.category='C'
				and $where
		
			      GROUP BY accno, description, charttype, category
		
				union
				
			      SELECT accno, chart.description, charttype, category,SUM(amount) as ob,0 as debit,
			      0 AS credit,count(accno)-1 as count
			      FROM chart, acc_trans,gl
			      WHERE chart.id = acc_trans.chart_id and  acc_trans.trans_id = gl.id and chart.category='C'
			      and (gl.transtype='OB' or gl.transtype='OU')
				and $where
		
			      GROUP BY accno, chart.description, charttype, category
				union
		
			      SELECT accno, chart.description, charttype, category,SUM(amount) as ob,0 as debit,
			      0 AS credit,count(accno) as count
			      FROM chart, acc_trans,ou
			      WHERE chart.id = acc_trans.chart_id and  acc_trans.trans_id = ou.id and chart.category='C'
			      and (ou.transtype='OB' or ou.transtype='OU')
				and $where
		
			      GROUP BY accno, chart.description, charttype, category

		
		) as foo group by accno, description,charttype,category
	 
	 ) as foo


	 union
	 

	 select (select chart.accno from chart where chart.category='D' and  charttype='H') as accno,(select chart.description from chart where chart.category='D' and  charttype='H') as description,'A','C', sum(ob),sum(debit),sum(credit),sum(count) from 
	 (
		  select accno,description,charttype,category,sum(ob)*-1 as ob ,sum(debit) as debit,sum(credit) as credit, sum(count) as count from (
			      SELECT accno, description, charttype, category,0 as ob,
			      SUM(amount)*-1 AS debit,0 as credit,count(accno) as count
			      FROM chart, acc_trans
			      WHERE chart.id = acc_trans.chart_id and amount < 0 and chart.category='D'
				and $where
		
			      GROUP BY accno, description, charttype, category
		
				union
			      
			      SELECT accno, description, charttype, category,0 as ob, 0 as debit,
			      SUM(amount) AS credit,count(accno) as count
			      FROM chart, acc_trans
			      WHERE chart.id = acc_trans.chart_id and amount > 0 and chart.category='D'
				and $where
		
			      GROUP BY accno, description, charttype, category
		
				union
				
			      SELECT accno, chart.description, charttype, category,SUM(amount) as ob,0 as debit,
			      0 AS credit,count(accno)-1 as count
			      FROM chart, acc_trans,gl
			      WHERE chart.id = acc_trans.chart_id and  acc_trans.trans_id = gl.id and chart.category='D'
			      and (gl.transtype='OB' or gl.transtype='OU')
				and $where
		
			      GROUP BY accno, chart.description, charttype, category
				union
		
			      SELECT accno, chart.description, charttype, category,SUM(amount) as ob,0 as debit,
			      0 AS credit,count(accno) as count
			      FROM chart, acc_trans,ou
			      WHERE chart.id = acc_trans.chart_id and  acc_trans.trans_id = ou.id and chart.category='D'
			      and (ou.transtype='OB' or ou.transtype='OU')
				and $where
		
			      GROUP BY accno, chart.description, charttype, category

		) as foo group by accno, description,charttype,category
	 
	 ) as foo

	 
) as foo group by accno, description,charttype,category
|;

  if ($form->{accounttype} eq 'gifi') {
    $query = qq|SELECT g.accno, g.description, c.charttype, c.category,
		SUM(a.amount) AS amount
		FROM gifi g, chart c, acc_trans a
		WHERE c.id = a.chart_id
      		AND c.gifi_accno = g.accno and chart.category<>'C' and chart.category <>'D'
		AND $where
		GROUP BY g.accno, g.description, c.charttype, c.category
	     UNION
		SELECT '' AS accno, '' AS description, 'A' AS charttype, 'X' AS category,
		SUM(a.amount) AS amount
		FROM chart c, acc_trans a
		WHERE c.id = a.chart_id and chart.category<>'C' and chart.category <>'D'
		AND c.gifi_accno = ''
		AND $where
	     UNION
		SELECT g.accno, g.description, c.charttype, c.category, 0.0 AS amount
		FROM gifi g, chart c
		AND c.gifi_accno = g.accno and chart.category<>'C' and chart.category <>'D'
		ORDER BY accno|;
  }

#$form->dberror($query);
  $sth = $dbh->prepare($query);
  $sth->execute || $form->dberror($query);

  # calculate the debit and credit in the period
  while (my $ref = $sth->fetchrow_hashref(NAME_lc)) {
    $ref->{debit} = $form->round_amount($ref->{debit}, 2);
    $ref->{credit} = $form->round_amount($ref->{credit}, 2);
  # next if ($ref->{charttype} eq 'A' && $ref->{amount} == 0);

    push @{ $form->{TB} }, $ref;
  }

  $sth->finish;
  $dbh->disconnect;

}

1;
